extern int inhibit_rebuild;
int fix_page_param = 0;
int interactive = 0;

static char *sccs_sid = "@(#)browser.c	1.21 6/23/97";

/*
    This program is intended to be 4.3 BSD equivalent of BROWSER
	on the DEC-20.
    The major difference will be that this version will use
	configuration files rather than header files.  This will
	allow it to look at various directories, rather than having
	everything in one.  It also allows one to eliminate common
	(read redundant) file name components.
    There will be one root configuration file.  The name of this
	file will be compiled in according to the "MAIN_CONFIG"
	declaration in the header file.  If one has the environment
	variable "BROWSER_CONFIG" set, this will supercede
	"MAIN_CONFIG".  If one gives a command tail argument to
	browser, this will supercede both the "MAIN_CONFIG"
	declaration and the "BROWSER_CONFIG" environment.
    The format of the configuration files will be three strings per
	line.  The first string will define the entry type.  "F"
	means file - this entry is a file that may be looked at.  "C"
	means config - this entry is the name of a next-level 
	configuration file that is to be loaded.  "D" means
	directory - this entry is the name of a directory, all
	members of which will be loaded and examined.  The next
	string will be the file name.  From the first non-white
	character after the file name to the end of the line will be
	the description, or label, that will be shown to the user.
	This definition is recursive to a maximum depth of MAX_NEST.
    This code is basically K&R "C".  Exceptions include - use of
	environment variables via getenv (), perror () subroutine
	usage, vfork () and execlp (), and using stat () to get
	st_mtime - the last time of modification of the file.
	vfork and execlp are used only under X windows.  getenv ()
	is only used to read initial configuration, "xterm" set,
	HOME directory (for config file), and USER name (for
	notifying administrator of errors).

*/

#include "browser.h"
#include "path.h"
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

int X = 0;
    /*  flag to say if x-windows are activated  */
int silentbrowse = 0;
    /*  don't print hello . . . .  */
int X_x = 0, X_y = 0;
    /*  offsets of the X window that THIS window has been placed at */
int orig_x, orig_y;
    /*  where the x and y start, for cycling */
char *next_geometry;
    /*  will be loaded with geometry statement for next window  */
char *prog_name;
int autoread = 0;
    /*  if true, automatically read everything  */
long last_read = 0;
    /*  int rep of last date of read  */
int max_nest = MAX_NEST;
    /*  use variable to specify maximum nesting level  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

main (argc, argv)
int argc;
char **argv;
{   entries **config;
    int indx;
    char *stmp, *tail_config = NULL;
    extern int X, X_x, X_y, max_nest;
    extern char *next_geometry, *prog_name;

    inhibit_rebuild = 1;
    term_init ();  /*  to retreive termcap cl  */
/*  save the name with which program was called so we can
    use it later  */
    prog_name = *argv;
    for (stmp = *argv; *stmp != '\0'; stmp++)
	if (*stmp == '/')  /*  another directory in pgm name  */
	    prog_name = stmp + 1;

    next_geometry = (char *) emalloc (MAX_LINE);

    command_tail (argc, argv, &tail_config);
    if (X) max_nest = 2;  /*  don't need more levels if X  */

    if (!silentbrowse)
	hello ();

/*  allocate memory for the config structures  */
    config = (entries **) ecalloc (MAX_ENTRIES + 1, sizeof (entries *));
    for (indx = 0; indx < MAX_ENTRIES; indx++)
	config [indx] = (entries *) emalloc (sizeof (entries) + 2);
	
/*  get the master config file name initialized  */
    set_config (config, tail_config);
    display_node (config);

    printf ("\n\nGood bye!\n");
}   /*  end of main  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

command_tail (argc, argv, config_string)
/*  read command tail arguments.  return used config string in
    config_string, and set up applicable globals
*/
int argc;
char **argv, **config_string;
{   extern int X, X_x, X_y, orig_x, orig_y;
    extern char *next_geometry, *prog_name;
    extern int autoread;
    char *tmp_ptr, *getenv ();
    static char *news_name = "gene-news";

/*  set autoread if called with gene-news program name  */
    autoread = (strcmp (*argv, news_name) == 0);

/*  set X if xterm is defined as terminal type  */
    if ((tmp_ptr = getenv ("TERM")) != NULL)
	if ((strcmp (tmp_ptr, "xterm") == 0) || 
	    (strcmp (tmp_ptr, "xterms") == 0))
	{   X = 1;
	    X_x = 0; X_y = 0;
	    X_x += X_X_INCREMENT;
	    X_y += X_Y_INCREMENT;
	    orig_x = X_x; orig_y = X_y;
	    sprintf (next_geometry, "=80x50+%d+%d", X_x, X_y);
	}

    for (argv++; *argv != NULL; argv++)
    {   switch (uc_char (**argv))
	{   case 'C':  /*  config string is next argument  */
		argv++;
		if (*argv != NULL)
		    *config_string = *argv;
		else
		    argv--;  /*  to avoid error  */
		break;
	    case 'S':  /*  silentbrowse flag, used mainly for  */
		       /*    children in x version  */
		silentbrowse = 1;
		break;
	    case 'X':  /*  we are using X windows  */
		       /*  next two args if present are x and y  */
		argv++;
		X = 1;  /*  say we are using X  */
		X_x = 0; X_y = 0;  /*  reset them  */
		if (*argv != NULL)
		    sscanf (*argv, "%d", &X_x);
		else
		    argv--;  /*  to avoid error  */
		argv++;
		if (*argv != NULL)
		    sscanf (*argv, "%d", &X_y);
		else
		    argv--;  /*  to avoid error  */
		X_x += X_X_INCREMENT;
		X_y += X_Y_INCREMENT;
		orig_x = X_x; orig_y = X_y;
		sprintf (next_geometry, "=80x50+%d+%d", X_x, X_y);
		break;
	    case 'R':  /*  set last read date - again, usually  */
			/*  for successive calls  */
		sscanf (&((*argv) [1]), "%d", &last_read);
		break;
	    case 'U':  /*  set last read for which user  */
		set_last_read (&((*argv) [1]));
		break;
	    case 'A':  /*  set autoread  */
		autoread = 1;
		prog_name = (char *) emalloc (30);
		strcpy (prog_name, news_name);
		break;
	    default:
		printf ("Unknown option - %s\n", *argv);
	}
    }
    if (last_read == 0)
	set_last_read (NULL);
    if (autoread)
	X = 0;  /*  turn off autoread if X is enabled  */
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

set_last_read (user)
/*  if "user" == NULL, retrieves date stamp from file 
    $HOME/.Browser-read-dates; if not null, reads from
    $HOME/.Browser-read-dates-"user".  Then, it touches
    appropriate file.
*/
char *user;
{   char fname [300], *getenv (), *char_ptr;
    FILE *ftemp;
    struct stat buf;

    if ((char_ptr = getenv ("HOME")) != NULL)
    {	if (user == NULL)
	    sprintf (fname, "%s/.Browser-read-dates", char_ptr);
	else
	    sprintf (fname, "%s/.Browser-read-dates.%s", char_ptr,
		user);
    }

    last_read = (stat (fname, &buf) == 0) ? buf.st_mtime : 1;
/*  set to modify time; if can't stat file, set to 1 (if we set to
    0, then later code thinks it's never been set
*/
    if ((ftemp = fopen (fname, "w")) != NULL)
    {   fprintf (ftemp, "\n");
	fclose (ftemp);
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

browse (config)
entries ***config;
{   int level, next;
    extern int orig_x, orig_y;
    entries *next_node;
    char er_string [300];
    extern int X, X_x, X_y, max_nest;
    extern char *next_geometry;

    orig_x = X_x; orig_y = X_y;  /*  remember these to step back */
    level = 0;  /*  start at beginning  */
    do
    {   display_node (config [level]);
	next = get_answer (config [level]);
	if ((next == NX_QUIT) || (next == NX_REDISPLAY))
	    continue;
	if (next == NX_BACKUP)
	{   if (X)
	    {	X_x = orig_x; X_y = orig_y;
		sprintf (next_geometry, "=80x50+%d+%d", X_x, X_y);
	    }
	    else if (level > 0)
		level--;  /*  step back up  */
	    continue;
	}
/*  point next_node to the selected node  */
	next_node = config [level][next];
	if (X)  /*  we are using X-windows, put in new window  */
	   window_node (next_node);
        else switch (uc_char (next_node -> type))
	{   case 'C':  /*  we have a new config file  */
	    case 'D':  /*  we have a new config directory  */
		strcpy (config [level + 1][0] -> description, 
		    next_node -> description);
		strcpy (config [level + 1][0] -> name,
		    next_node -> name);
		config [level + 1][0] -> type = next_node -> type;
		level = level + 1;   /*  step to next level  */
		if (level >= max_nest)  /*  too deep  */
		{   sprintf (er_string, 
			"nested beyond %d reading %s\n", max_nest,
			next_node -> description);
		    er_exit (er_string);
		}
		run_config (config [level]);
		  /*  load new config level  */
		break;
	    case 'F':  /*  show a file  */
		display_node (&next_node);
		break;
	    default:
		sprintf (er_string, "unknown type %c for %s\n",
		    next_node -> type, next_node -> description);
		er_exit (er_string);
	}
    }   while (next != NX_QUIT);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

set_config (initial_config, tail)
entries **initial_config;
char *tail;
{   char *config, *getenv ();

/*  determine config initialization  */
/*  first, get the overall compiled in default  */
    config = MAIN_CONFIG;
/*  possibly override from environment variable  */
    if (getenv ("BROWSER_CONFIG") != NULL)
	config = getenv ("BROWSER_CONFIG");
/*  possibly override from command tail argument  */
    if (tail != NULL)
	config = tail;
    str_to_entry (config, initial_config [0]);
}   /*  end of set_config  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

hello ()
{   extern char *prog_name;
    char resp [200], *ptr;

    ptr = prog_name;
    printf ("\n\n\t\t- - - -  ");
    while (*ptr != '\0')
    {	putchar (uc_char (*ptr));
	ptr++;
	putchar (' ');
    }
    printf (" - - - -\n\n\n");
    printf ("On line browsing for the MBCRR utilities\n");
    printf ("    databases, and other information.\n\n");
    printf ("Hit <CR> to begin browsing -> ");
    fgets (resp, 200, stdin);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

