
static char *sccs_sid = "@(#)browser_build_dates.c	1.9 6/25/87";

/*  this program will generate the dates file for browser  */

/*  this program recursively reads the browser configuration file,
    and sets dates accordingly.  It's only configuration is from
    the declarations in "browser.h", as it is assumed that there
    will, in general, be only one "browser" set on a machine
    (perhaps there are several entry points, however . . .).
    The program will print out the integer rep of the modification
    dates with the associated FILE name to the dates file.  This
    integer is as returned by stat () in st_mtime.  Recursion will
    be trapped.

    Browser will automatically fork to this program if it detects
    inconsistencies (dates on files do not agree, file not in dates
    list, date file does not exist . . .), hence its level of hard
    wiring.  It assumed that this program will be sgid or suid to
    allow it to write to the date file.
*/

#include <stdio.h>
#include "browser.h"
#include "path.h"
#include <sys/types.h>
#include <sys/stat.h>

#define MAX_BROWSER_FILES 2000
    /*  maximum number of files that can be visited  */
int fix_page_param = 0;
int interactive = 0;
int silentbrowse = 0;
int last_read = 0;
/*  above two just so we can use browser modules  */
int max_nest = MAX_NEST;
    /*  variable should be used, not constant  */
char **used_files;
    /*  list of files visited - for detecting recursion  */
char *prog_name;
int files_visited = 0;
int highest_level = 0;
char *next_geometry;
int X, X_x, X_y, orig_x, orig_y, autoread;

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

main (argc, argv)
int argc;
char **argv;
{   entries top_node;
    int indx;
    FILE *fout;
    extern char **used_files, *prog_name;
    extern int files_visited, highest_level;

    prog_name = *argv;
    used_files = 
	(char **) ecalloc (MAX_BROWSER_FILES + 1, sizeof (char *));
    *used_files = NULL;

    printf ("\n\nBuilding browser dates.\n");

    if ((fout = fopen (DATE_FILE, "w")) == NULL)
    {	printf ("\nCould not open date file %s\n", DATE_FILE);
	exit (1);
    }

/*  get configuration from declaration only  */
    str_to_entry (MAIN_CONFIG, &top_node);
/*  doit works recursively  */
    doit (&top_node, fout, 1);
    fclose (fout);
    printf ("\n%d files visited, max is %d\n", files_visited,
	MAX_BROWSER_FILES);
    if (highest_level > MAX_NEST)
	printf ("Warning - nest at level %d, max is %d\n",
	    highest_level, MAX_NEST);
    else
	printf ("Highest nesting level: %d, max is %d\n", 
	    highest_level, MAX_NEST);
    printf ("\nCompleted\n");
}

doit (node, fout, level)
entries *node;
FILE *fout;
int level;
{   entries **list;
    int indx, file_num;
    long mod_date, ltemp;
    struct stat buf;
    char stemp [200];
    extern char **used_files, *prog_name;
    extern int files_visited, highest_level;

    if (level > highest_level)
	highest_level = level;
    if ((file_num = tracker (node -> name, used_files)) == -1)  
/*  we have recursion */
    {	printf ("Warning - recursion to file \"%s\",\n", node -> name);
        printf ("  description \"%s\"\n", node -> description);
	return (0);  /*  DON'T KNOW WHAT TO RETURN ! ! !  */
    }

    if (file_num >= MAX_BROWSER_FILES)
    {   sprintf (stemp, "More than %d files for %s\n", 
	    MAX_BROWSER_FILES, prog_name);
	er_exit (stemp);
    }

    files_visited++;

    switch (node -> type)
    {	case 'F':
	    if (stat (node -> name, &buf) == -1)
	    {	sprintf (stemp, "Could not stat file %s", 
		    node -> name);
		perror (stemp);
		fprintf (fout, "%s %ld\n", node -> name, 0);
		return (0);
	    }
	    fprintf (fout, "%s %ld\n", node -> name, buf.st_mtime);
	    return (buf.st_mtime);
	    break;
	case 'C':
	    list = (entries **) ecalloc (MAX_ENTRIES + 2, 
		sizeof (entries *));
	    for (indx = 1; indx < MAX_ENTRIES; indx++)
		list [indx] = 
			(entries *) emalloc (sizeof (entries) + 2);
	    list [0] = node;
	    if (stat (node -> name, &buf) == -1)
	    {	sprintf (stemp, "Could not stat config file %s", 
		    node -> name);
		perror (stemp);
		return (0);
	    }
	    mod_date = buf.st_mtime;
	    run_config (list);
	    for (indx = 1; list [indx] -> type != '\0'; indx++)
		if ((ltemp = doit (list [indx], fout, level + 1)) 
		    > mod_date)
		    mod_date = ltemp;
	    for (indx = 1; indx < MAX_ENTRIES; indx++)
	    	free (list [indx]);
	    free (list);
	    fprintf (fout, "%s %ld\n", node -> name, mod_date);
	    break;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */



