
static char *sccs_sid = "@(#)input.c	1.7 6/25/87";

#include "browser.h"
#include <stdio.h>

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

run_config (node)
/*  expand node "entry" to the node list "node"  */
entries **node;
/*  builds node according to node [0]  */
/*  returns boolean indicating success  */
{   char err_desc [300];

    switch (node [0] -> type)
    {	case 'C':
	case 'c':
	    file_config (node);
	    break;
	case 'D':
	case 'd':
	    directory_config (node);
	    break;
	case 'F':
	case 'f':
	    node [1] -> type = '\0';
	    break;
	default:
	    sprintf (err_desc, 
		"browser error - bad configuration type %c for %s\n",
		node [0] -> type, node [0] -> description);
	    er_exit (err_desc);
	    break;
    }
}   /*  end of run_config  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

directory_config (node)
/*  expand directory name dir_name to entry list "node"  */
entries **node;
{   char err_str [300];

    sprintf (err_str, "directory config not implemented, %s\n",
	node [0] -> name);
    er_exit (err_str);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

file_config (node)
/*  read configuration file fname to generate entry list node  */
entries **node;
{   FILE *finp;
    char err_str [300], stemp [MAX_LINE], *fname;
    int indx;

    fname = node [0] -> name;
/*  open the configuration file  */
    if ((finp = fopen (fname, "r")) == NULL)
    {	sprintf (err_str, "could not read config file %s\n", fname);
    	er_exit (err_str);
    }
    fclose (finp);
    sprintf (stemp, "ul %s", fname);
    finp = popen (stemp, "r");
    if (finp == NULL)
    {	sprintf (err_str, "could not read config file %s\n", fname);
    	er_exit (err_str);
    }
/*  read and store each line  */
    for (indx = 1; fgets (stemp, MAX_LINE, finp) != NULL; indx++)
    {	if (*stemp != '#')  /*  # in column 1 to comment out  */
	{   str_to_entry (stemp, node [indx]);
	    if (indx >= MAX_ENTRIES)  /*  too many nodes  */
	    {   sprintf (err_str, 
		    "config file %s more than %d entries\n", fname,
		    MAX_ENTRIES);
		er_exit (err_str);
	    } 
	}
    }
    pclose (finp);

/*  terminate the list by flaging type  */
    node [indx] -> type = '\0';
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

str_to_entry (line, entry)
/*  converts string line into an entry format  */
char *line;
entries *entry;
{   char *j;
    int indx;

    entry -> type = *line;  /*  eat first character as type  */
    line++;

    while (*line <= ' ')  /*  get up till first white space  */
	line++;

/*  get the next field - the name  */
    j = entry -> name;
    while (*line > ' ')
    {	*j = *line;
	j++; line++;
    }
    *j = '\0';

    line++;  /* step past white  */
    strcpy (entry -> description, line);
    indx = strlen (entry -> description) - 1;
    j = &((entry -> description) [indx]);
    while ((*j <= ' ') && (j >= entry -> description))
    {	*j = '\0';
	j--;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

