
static char *sccs_sid = "@(#)output.c	1.15 12/2/87";

#include "browser.h"
#include "path.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

/*  static char *SO = "\33[4m", *SI = "\33[m";  */
    /*  stand out and stand in  */

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

cfg_entry_display (node)
entries *node;
{   extern long last_read;
    long mod_time, date_of_mod ();
    char *int_to_date ();

    printf ("NODE %s\n", 
	node -> description);
    printf ("\tLast modified ");
    mod_time = date_of_mod (node);
    if (last_read < mod_time)
    {   stand_out ();
	printf ("%s", int_to_date (mod_time));
	stand_out_end ();
	printf ("\n");
    }
    else
	printf ("%s\n", int_to_date (mod_time));
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

file_entry_display (node)
entries *node;
{   extern long last_read;
    struct stat buf;
    long mod_time, date_of_mod ();
    char stemp [200], *int_to_date ();
    FILE *ferr;

    mod_time = date_of_mod (node);

    if (stat (node -> name, &buf) == 0)
    {   if (buf.st_mtime != mod_time)
/*  then file times file is inconsistent  */
	{   sprintf (stemp, 
		"Entry for file %s out of date\n",
		node -> name);
	    rebuild_dates (stemp);
	    mod_time = buf.st_mtime;
	}
	printf ("FILE %s\n", node -> description);
	printf ("\tLast modified ");
	if (last_read < mod_time)
	{   stand_out ();
	    printf ("%s", int_to_date (mod_time));
	    stand_out_end ();
	    printf (", ");
	}
	else
	    printf ("%s, ", int_to_date (mod_time));
	printf ("%d characters\n", buf.st_size);
    }
    else
    {   sprintf (stemp, "\nWarning, could not stat file %s",
	    node -> name);
	perror (stemp);
	if ((ferr = fopen (ERROR_FILE, "a")) == NULL)
	    printf ("Administrator not notified.\n\n");
	else
	{   fprintf (ferr, "%s\n", stemp);
	    fprintf (ferr, "Called from %s\n", 
		node -> description);
	    fprintf (ferr, "********************\n");
	    fclose (ferr);
	    printf ("Administrator notified.\n\n");
	}
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

display_node (node)
/*  root is the node label, node is the actual list of entries
    display each
*/
entries **node;
{   int indx, next;
    long mod_time, date_of_mod ();
    char er_msg [300], *getenv (), stemp [100], *int_to_date ();
    struct stat buf;
    FILE *ferr;
    extern long last_read;
    extern int X, autoread;
    entries **next_node;

    next_node = NULL;


    if (node [0] -> type == 'F')
    {	clear_screen ();
	printf (" - - FILE - - %s - -\n", 
	    node [0] -> description);
	show_file (node [0]);
	return;
    }

    run_config (node);

    if (autoread)
    {   for (next = 1; node [next] -> type != '\0'; next++)
	{   
	    if (last_read < date_of_mod (node [next]))
	    {   if (X)
		    window_node (node [next]);
		else
		{   if (node [next] -> type == 'F')
			display_node (&node [next]);
		    else
		    {   if (next_node == NULL)
			{   next_node = (entries **) 
				ecalloc (MAX_ENTRIES + 2, 
				sizeof (entries *));
			for (indx = 1; indx < MAX_ENTRIES; indx++)
			    next_node [indx] = (entries *) 
				emalloc (sizeof (entries) + 2);
			}
			next_node [0] = node [next];
			display_node (next_node);
		    }
		}
	    }
	}
    }
    else do
    {   clear_screen ();
	printf (" - - MENU - - %s - -\n", 
	    node [0] -> description);
	print_node (node);

	switch (next = get_answer (node))
 	{   case NX_QUIT:
		break;
	    case NX_BACKUP:
		next = NX_QUIT;
		break;
	    case NX_REDISPLAY:
		break;
	    case NX_INVALID:
		break;
	    default:  /*  we have a good new number  */
		if (X)
		    window_node (node [next]);
		else
		{   if (node [next] -> type == 'F')
			display_node (&node [next]);
		    else
		    {   if (next_node == NULL)
			{   next_node = (entries **) 
				ecalloc (MAX_ENTRIES + 2, 
				sizeof (entries *));
			    for (indx = 1; indx < MAX_ENTRIES; indx++)
				next_node [indx] = (entries *) 
				    emalloc (sizeof (entries) + 2);
			}
			next_node [0] = node [next];
			display_node (next_node);
		    }
		}
		break;
	}
    }   while (next != NX_QUIT);

    if (next_node != NULL)
    {	for (indx = 1; indx < MAX_ENTRIES; indx++)
	    free (next_node [indx]);
	free (next_node);
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

print_node (node)
entries **node;
{   int indx;
    char er_msg [200];

    for (indx = 1; node [indx] -> type != '\0'; indx++)
    {   printf ("%3d ) ", indx);
	switch (node [indx] -> type)
	{   case 'C':  /*  config file  */
	    case 'D':  /*  directory  */
		cfg_entry_display (node [indx]);
		break;
	    case 'F':  /*  a regular file  */
		file_entry_display (node [indx]);
		break;
	    default:  /*  ? ? ? ? ?  */
		sprintf (er_msg, 
		    "displaying %s -> %s, unknown type %c\n", 
			node [0] -> description, node [indx] -> 
			description, node [indx] -> type);
		er_exit (er_msg);
		break;
	}
    }
}
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

char *int_to_date (mod_time)
/*  sets month, date, and year of mod_time into string it returns */
long mod_time;
{   char *tim_str, *ctime ();

    tim_str = ctime (&mod_time);
    tim_str += 4;  /*  past dow  */
    tim_str [7] = '\'';
    tim_str [8] = tim_str [18];
    tim_str [9] = tim_str [19];
    tim_str [10] = '\0';
    return (tim_str);
}
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

show_file (node)
entries *node;
{   char cmd [300];

/*    sprintf (cmd, "ul %s | more -s -d -f", node -> name); */
    sprintf (cmd, "more -s -d -f %s", node -> name); 
    system (cmd);
    printf ("\nEnd of file - Hit <CR> to continue -> ");
    fgets (cmd, 300, stdin);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

er_exit (cause)
/*  fatal error encountered, description is in cause.
    print cause, and try to put cause, time, and user to error
    log file
*/
char *cause;
{   char *cptr, *getenv (), cmd_str [300],
	*ctime ();
    FILE *ftmp;
    long tim;

    printf ("\n\n\7 - - - - BROWSER FAILURE - - - -\n");
    printf ("%s\n\n", cause);
    if ((ftmp = fopen (ERROR_FILE, "a")) == NULL)
    {	printf ("Could not write to log file %s\n", ERROR_FILE);
	printf ("  Administrator not notified\n");
    }
    else
    {	time (&tim);
	fprintf (ftmp, "Browser error, %s", ctime (&tim));
	if ((cptr = getenv ("USER")) != NULL)
	    fprintf (ftmp, "User %s\n", cptr);
	fprintf (ftmp, "%s\n", cause);
	fprintf (ftmp, "****************************************\n\n");
	fclose (ftmp);
	printf ("Administrator notified\n");
    }
    printf ("Exiting.\n");
    exit (1);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

window_node (node)
entries *node;
/*  build a new browser window for node  */
{   char stemp [300], x_string [30], y_string [30], date_str [40];
    extern int X, X_x, X_y, last_read, orig_x, orig_y;
    extern char *next_geometry, *prog_name;
    int pid;

    sprintf (date_str, "R%d", last_read);
/*  build the descriptor for node  */
    sprintf (stemp, "%c %s %s", node -> type, node -> name,
	node -> description);
    sprintf (x_string, "%d", X_x);
    sprintf (y_string, "%d", X_y);

    if ((pid = vfork ()) == 0)
    {	execlp ("xterm", prog_name,  next_geometry, "-e", prog_name,
	    "S", "C", stemp, date_str, "X", x_string, y_string, NULL);
	perror ("\n\nEXECLP FAILURE ! ! \n\n");
	fflush (stderr);
	_exit ();
    }
    if (pid == -1)
	perror ("\n\nERROR - VFORK FAILURE\n\n");

    X_x += X_X_CHILD_INCREMENT;
    X_y += X_Y_CHILD_INCREMENT;
    if (X_x > (orig_x + X_X_INCREMENT))
/*  then we need to start back at beginning  */
    {   orig_x += 2;  orig_y += 2;
	X_x = orig_x;  X_y = orig_y;
    }
    sprintf (next_geometry, "=80x50+%d+%d", X_x, X_y);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

do_shell (comd_str, node)
char *comd_str;
entries **node;
{   char strng [400], *str_ptr;
    int j, num_nodes;

    for (num_nodes = 0; node [num_nodes] -> type != '\0';
	num_nodes++);
    str_ptr = strng;
    *strng = '\0';
    while (*comd_str != '\0')
    {   if (*comd_str == '$')  /*  replacement  */
	{   comd_str++;
	    if (*comd_str == '$')
	    {   *str_ptr = '$';
		str_ptr++;
		comd_str++;
	    }
	    else
	    {   j = 0;
		while ((*comd_str >= '0') && (*comd_str <= '9'))
		{   j = j * 10 + *comd_str - '0';
		    comd_str++;
		}
		if (j >= num_nodes)
		{   printf ("\nShell error - only %d nodes present, ", 
			num_nodes - 1);
		    printf ("%d requested\n", j);
		    printf ("Shell command aborted.\n");
		    printf ("Hit <CR> to continue -> ");
		    fgets (strng, 199, stdin);
		    return;
		}
		strcpy (str_ptr, node [j] -> name);
		while (*str_ptr != '\0') str_ptr++;
	    }
	}
	else
	{   *str_ptr = *comd_str;
	    str_ptr++;
	    comd_str++;
	}
    }
    *str_ptr = '\0';
    system (strng);
    printf ("\nHit <CR> to continue -> ");
    fgets (strng, 199, stdin);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

