#ifndef LINT
static char *sccs_sid = "@(#)apropos.c	1.11 3/21/89 WINLIB";
#endif

#include <stdio.h>
#include <setjmp.h>
#include <signal.h>

#include "curses.h"
#include "../lib/regex.h"

static int get_rec ();

char *apropos_history [300] = { "." };
/*STARTDOC*/
apropos ()
/*  show commands that reference the ``key'' string 
    (input from kbd)
*/
/*ENDDOC*/
{   char stemp [300];

    *stemp = '\0';
    win_prompt (stdscr, LINES - 2, "Apropos", stemp, 
	apropos_history, 0, "Apropos");
    run_apropos (stemp);
}

static jmp_buf apropos_push;

static pipe_error ()
{   longjmp (apropos_push, 1);
}

/*STARTDOC*/
run_apropos (string)
/*  show commands that reference the ``key'' string 
    (key is string)
*/
/*ENDDOC*/
char *string;
{   char fname [300], buf [4000], parsed [400], *re_rtn, ick [300];
    FILE *fapropos, *pout, *pip;
    extern char HELP_DIRS [];
    struct re_pattern_buffer re_buf;
    int blen;

    if (setjmp (apropos_push))  {
	pclose (pout);
	clean_bottom ();
	full_screen_mode ();
	return;
    }

    sprintf (fname, "%sAproposFile", HELP_DIRS);
    if (!(fapropos = fopen (fname, "r")))
    {   move (LINES - 2, 0);
	printw ("No apropos file \"%s\"", fname);
	printf ("\007"); fflush (stdout);
	Pause (0);
	return;
    }
    re_rtn = re_parse (string, parsed);
    re_buf.allocated = 200;
    re_buf.buffer = (char *) emalloc (200);
    re_buf.fastmap = (char *) emalloc (2200);
    re_buf.translate = re_ignorecase;
    if (!re_rtn)
	re_rtn = re_compile_pattern (parsed, strlen (parsed), &re_buf);
    if (re_rtn)
    {   move (LINES - 2, 0);
	printw ("Bad regex \"%s\": \"%s\"", string, re_rtn);
	Pause (0);
	free (re_buf.fastmap);
	free (re_buf.buffer);
	return;
    }
    tty_mode ();
    pip = pout = popen ("more", "w");
    if (!pout)
	pout = stdout;
    signal (SIGPIPE, pipe_error);

    while (blen = get_rec (fapropos, buf))
    {   if (re_search (&re_buf, buf, blen, 0, blen, 0) >= 0)
	{   fputs (buf, pout);
	    fflush (pout);
	}
    }
    if (pip)
	pclose (pout);
    else
	fclose (pout);
    free (re_buf.fastmap);
    free (re_buf.buffer);
    printf ("Hit <CR> to continue -> ");
    fflush (stdout);
    fgets (ick, 300, stdin);
    clean_bottom ();
    full_screen_mode ();
    return;
}

static int get_rec (f, b)
FILE *f;
char *b;
{   char *bstart, firstc;

    if (feof (f))
	return (0);
    bstart = b;

    do
    {   if (!fgets (b, 200, f))
	    return ((int) (b - bstart));
	firstc = *b;
	while (*b)
	    b++;  /*  advance to the end of the string  */
    }   while (firstc != '\n');  /*   stop at first blank line  */
    return ((int) (b - bstart));
}

