#ifndef LINT
static char *sccs_sid = "@(#)clib.c	2.2 4/25/89 FAULKNLIB";
#endif

#include <stdio.h>
#include <ctype.h>
#include "faulkn.h"
/*STARTDOC*/

/*  included in this unit are:

    int get_yes_no (prompt, default)
        char *prompt, *default
        prompts user with "prompt"
        if user types yes, y, t, true response - returns 1
        if user types no, n, f, false response - returns 0
        continually prompts user until answer is in set
        set "default" to NULL for no default answer
        case is not significant
	if user EOF's, returns according to default; if
	    default not set, returns as FALSE

    char *uc_string (string)
        char *string
        converts string to all upper case letters
	returns pointer to string converted

    char *lc_string (string)
        char *string
        converts string to all lower case letters
	returns pointer to string converted

    char uc_char (character)
        char character
        returns upper case version of "character"

    char lc_char (character)
        char character
        returns lower case version of "character"

    int get_response (string, prompt, default)
        char *string, *prompt, *default
        prompts user with "prompt"
        if "default" is not NULL, it serves as default answer
        returns user response in "string"
	returns 0x0 if EOF, else 0x1
        if user EOF's, returns default; if no default set, 
	    will return "" in string

    int get_input (string)
        char *string
        gets line of input from keyboard - strips nl from end
	returns 0x0 if EOF, else 0x1

    int member (a, b, c, ...)
        char *a, *b, *c . . .
        list of character pointers is NULL terminated
        returns 1 if "a" is equal to any of terms, 0 if not

    int get_integer (prompt, min_good, default, max_good)
	char *prompt
	int min_good, default, max_good
	gets a digit of input from user, "default" is the
	default.  response must be between min_good and
	max_good.

    float get_float (prompt, min_good, default, max_good)
	same as get_integer, but for floats

    char peek_char (file)
	FILE *file;
	returns next character that would be returned
	by a read to file.
    
    int strmatch (query, test)
	char *query, *test;
	returns true if running reg_ex query against test
	    returns 1
    char *emalloc (number)
	int number
	as malloc, but prints error message and dies if 
	fails

    char *ecalloc (number, size)
	as above

    char *blstrip (string)
	char *string
	remove preliminary and trailing white spaces from "string"
	return pointer to the string
    char *new_string (string)
	char *string
	returns a pointer to a emalloc'ed block containing a copy
	    of string
*/
/*ENDDOC*/

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
int get_yes_no (prompt, in_default)
/*  returns 1 if user answers "YES" or "Y" or "TRUE" or "T"
    returns 0 if user answers "NO" or "N" or "FALSE" or "F"
    case is ignored
    if user EOF's, returns according to in_default or 0x0
*/
/*ENDDOC*/
char
    *prompt;
char
    *in_default;
{   char
        response [200];
    int
        yes, no, get_returned;

    do
    {   get_returned = get_response (response, prompt, in_default);
        uc_string (response);
        yes = member (response, "YES", "Y", "TRUE", "T", NULL);
        no = member (response, "NO", "N", "FALSE", "F", NULL);
        if ((!yes) && (!no))
	{   if (get_returned == 0)
	    {	printf ("\nEOF - Default to NO\n");
		return (0);
	    }
	    else printf ("\nPlease answer \"Yes\" or \"No\".\n");
	}
    }   while ((!yes) && (!no));
    return (yes);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
char *uc_string (string)
/*  convert string to all uppercase  
    returns pointer to converted string
*/
/*ENDDOC*/
char *string;
{   char *start_string;

    start_string = string;
    while (*string != '\0')
    {   *string = uc_char (*string);
        string++;
    }
    return (start_string);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
char uc_char (character)
/*  returns upper case of character  */
char character;
/*ENDDOC*/
{  
    if (islower (character))
#ifdef usg
	return (_toupper (character));
#else
	return (toupper (character));
#endif
    else
	return (character);
#if 0
    if (character >= 'a')
        character -= ('a' - 'A');
    return (character);
#endif
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
char *lc_string (string)
/*  convert string to all uppercase  
    returns pointer to converted string
*/
/*ENDDOC*/
char *string;
{   char *start_string;

    start_string = string;
    while (*string != '\0')
    {   *string = lc_char (*string);
        string++;
    }
    return (start_string);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
/*STARTDOC*/
char lc_char (character)
/*  returns lower case of character  */
char character;
/*ENDDOC*/
{
    if (isupper (character))
#ifdef usg
	return (_tolower (character));
#else
	return (tolower (character));
#endif
    else
	return (character);
#if 0
    if (character <= 'Z')
        character -= ('A' - 'a');
    return (character);
#endif
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
int get_response (string, prompt, in_default)
/*  prompts user with prompt, returns his response.  if <CR>,
    default is in_default.  if in_default is NULL, then forces response.
    returns 1 if answered, 0 if EOF'ed
    string and in_default may be the same pointer
*/
char *string, *prompt, *in_default;
/*ENDDOC*/
{   char stemp [200], internal_default [200];
    int done;

/*  determine if there is a default.  if there is a default,
    copy it.  it is copied so that the default and response string
    can be the same */

    if (in_default != NULL)
        strcpy (internal_default, in_default);
    else
	internal_default [0] = '\0';

    do
    {   fputs (prompt, stdout);
        if ((in_default != NULL) && *in_default)
            printf (", or <CR> for %s", internal_default);
        fputs (" -> ", stdout);
	fflush (stdout);
        if (get_input (stemp) == 0)  /*  end of file  */
        {   if ((in_default != NULL) && *in_default)
                strcpy (string, in_default);
	    else
/*  if no default and user EOF's, return ""  */
		string [0] = '\0';
            printf ("\n\nEOF - default to \"%s\"\n", string);
	    fflush (stdout);
            return (0);
        }
        if (stemp [0] == '\0')
/*  user just typed <CR>, see if there is a default  */
        {   if ((in_default == NULL) || !*in_default)
/*  if there is a default, user cannot type just <CR>  */
            {   printf ("Sorry, no default.\n");
		fflush (stdout);
                done = 0;
            }
            else
            {   strcpy (string, internal_default);
                done = 1;
            }
        }
        else
/*  if user is not using default, save the string he has entered */
        {   strcpy (string, stemp);
            done = 1;
        }
    }   while (!done);
    fflush (stdout);
    return (1);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

int get_input (string)
/*  gets input from key board - strips <CR> at end (if present)
    returns 0 if EOF - else 1
*/
char *string;
{   int index;

    if (fgets (string, 199, stdin) == NULL)
    {   string [0] = '\0';
	return (0);
    }
    index = strlen (string) - 1;
    if (index >= 0)
    {   if (string [index] == '\n')
            string [index] = '\0';
    }
    return (1);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
int member (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s,
    t, u, v, w, x, y, z)
/*  returns 0x1 if string a is equal to any of the subsequent
    arguments
*/
/*ENDDOC*/
char *a, *b, *c, *d, *e, *f, *g, *h, *i, *j, *k, *l, *m, *n, *o, *p,
    *q, *r, *s, *t, *u, *v, *w, *x, *y, *z;
{
    if (b == NULL)
        return (0);
    if (strcmp (a, b) == 0)
        return (1);
    return (member (a, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r,
	s, t, u, v, w, x, y, z));
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
int get_integer (prompt, min_good, deflt, max_good)
/*  prompts user with "prompt" to enter a number
    response must be >= min_good and <= max_good
*/
char *prompt;
int min_good, deflt, max_good;
/*ENDDOC*/
{   char cdefault [200], cresponse [200], *stemp;
    int response, bad_response;

    if (!((min_good <= deflt) && (deflt <= max_good)))
    {	fprintf (stderr, "\n\nPANIC - notify programmer:\n");
	fprintf (stderr, "BAD GET_integer PARAMETERS\n\n");
	exit (1);
    }

    sprintf (cdefault, "%d", deflt);
    do
    {	if (get_response (cresponse, prompt, cdefault) == 0)
	    return (deflt);
	bad_response = 0;
	stemp = cresponse;
	if (*stemp == '-')
	    stemp++;
	for (; *stemp != '\0'; stemp++)
	    if ((*stemp < '0') || (*stemp > '9'))
		bad_response = 1;
	if (bad_response)
	    printf ("\nSorry, you must enter a number\n");
	else
	{   sscanf (cresponse, "%d", &response);
	    if ((response < min_good) || (response > max_good))
	    {	bad_response = 1;
		printf ("\nSorry, your answer must be between ");
		printf ("%d and %d\n", min_good, max_good);
	    }
	}
    }	while (bad_response);

    fflush (stdout);
    return (response);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
float get_float (prompt, min_good, deflt, max_good)
/*  prompts user with "prompt" to enter a number
    response must be >= min_good and <= max_good
*/
char *prompt;
float min_good, deflt, max_good;
/*ENDDOC*/
{   char cdefault [200], cresponse [200], *stemp;
    int bad_response;
    float response;

    if (!((min_good <= deflt) && (deflt <= max_good)))
    {	fprintf (stderr, "\n\nPANIC - notify programmer:\n");
	fprintf (stderr, "BAD GET_FLOAT PARAMETERS\n\n");
	exit (1);
    }

    sprintf (cdefault, "%f", deflt);
    do
    {	if (get_response (cresponse, prompt, cdefault) == 0)
	    return (deflt);
	bad_response = 0;
	stemp = cresponse;
	if (*stemp == '-')
	    stemp++;
	for (; *stemp != '\0'; stemp++)
	    if (((*stemp < '0') || (*stemp > '9')) && 
		(*stemp != '.'))
		bad_response = 1;
	if (bad_response)
	    printf ("\nSorry, you must enter a number\n");
	else
	{   sscanf (cresponse, "%f", &response);
	    if ((response < min_good) || (response > max_good))
	    {	bad_response = 1;
		printf ("\nSorry, your answer must be between ");
		printf ("%f and %f\n", min_good, max_good);
	    }
	}
    }	while (bad_response);
    fflush (stdout);

    return (response);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

char peek_char (file)
/*  returns character that will next be read from stream file  */
FILE *file;
{   int j;
    j = getc (file);
    ungetc (j, file);
    return (j);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

strmatch (query, test)
char *query, *test;
{   char *re_result, *re_comp ();

    if ((re_result = re_comp (query)) != NULL)
    {	printf ("REGEX error with \"%s\": %s\n", query, re_result);
	return (0);
    }
    if (re_exec (test, 0) == 1)
	return (1);
    return (0);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
char *emalloc (n_elements)
/*  runs malloc.  dies if malloc fails  */
int n_elements;
/*ENDDOC*/
{   char *malloc (), *stemp;
    if ((stemp = malloc (n_elements)) == NULL)
    {   fprintf (stderr, "\n\nPANIC - malloc failed\n");
	fprintf (stderr, "Trying to allocate %d\n", n_elements);
	exit (1);
    }
    return (stemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/*STARTDOC*/
char *ecalloc (n_elements, element_size)
/*  runs calloc.  dies if calloc dies  */
int n_elements, element_size;
/*ENDDOC*/
{   char *calloc (), *stemp;
    if ((stemp = calloc (n_elements, element_size)) == NULL)
    {   fprintf (stderr, "\n\nPANIC - calloc failed\n");
	fprintf (stderr, "Trying to allocate %dx%d\n", n_elements,
	    element_size);
	exit (1);
    }
    return (stemp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

char *blstrip (string)
char *string;
/*  removes white characters from beginning and end of string  */
{   int indx, indx2, indx3;

    for (indx = 0; string [indx] <= ' '; indx++);
    for (indx2 = strlen (string); string [indx2] <= ' '; indx2--);
    for (indx3 = 0; indx <= indx2; indx3++)
    {	string [indx3] = string [indx];
	indx++;
    }
    string [indx3] = '\0';
    return (string);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

char *new_string (string)
char *string;
{   char *tmp;

    tmp = (char *) emalloc (strlen (string) + 5);
    strcpy (tmp, string);
    return (tmp);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

