#ifndef LINT
static char *sccs_sid = "@(#)curs_lib.c	2.3 4/5/89 WINLIB";
#endif

debug ()
{
}

#include <stdio.h>
#include <strings.h>
#include "extern.h"
#include "curses.h"
#include "term.h"
#include "faulkn.h"
#include "win-types.h"

int incremental_complete = 1;
static char **fs_aliases, **fs_substitutes;
int found [5000];

extern int prefix ();
extern prefix_block *prefix_top, *new_prefix (), *insert_prefix (),
    *prefix_lookup ();

#define CMD_UP 1
#define CMD_DOWN 2
#define CMD_LEFT 3
#define CMD_RIGHT 4
#define CMD_HELP 5 
#define CMD_APROPOS 6

int (*cmd_up) ()= 0, (*cmd_down) () = 0,
    (*cmd_left) () = 0, (*cmd_right) () = 0,
    (*cmd_help) () = 0, (*cmd_apropos) () = 0;

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/*STARTDOC*/
int win_prompt (wind, y, prompt, str, old, menu, help)
WINDOW *wind;
int y, menu;
char *str, **old, *prompt, *help;
/*  prompt user for input.
    wind is the window to use
    y is the line to do it on (it will be done at column 0)
    prompt will be displayed
    user input will be returned in str (number of menu item
	selected will be returned by the call, also)
    old is the history list (menu list if menu)
    menu says if this is a menu item
    help names help information - directory if it is a menu,
	file if not a menu
*/
/*ENDDOC*/
{   int len, ix;
    char ick [200];

    sprintf (ick, "%s -> ", prompt);
    wmove (wind, y, 0);
    len = strlen (ick);
    if (menu)
    {   len += 2;
	wstandout (wind);
	waddstr (wind, "M");
	wstandend (wind);
	waddstr (wind, " ");
    }
    waddstr (wind, ick);
    ix = win_string (wind, y, len, str, old, menu, help);
    wmove (wind, y, 0);
    wrefresh (wind);
    return (ix);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/*STARTDOC*/
int win_string (wind, y, x, str, old, menu, help)
/*  read string from window "wind" at "y, x", into str  */
/*  allows limited editing  */
/*  return index of choice  */
/*  if old is null, use an internal table.
    if str is null, use internal str (only for menu)
*/
WINDOW *wind;
int y, x, menu;
char *str, **old, *help;
/*ENDDOC*/
{   char stemp [200], *new_string (), intern_str [200], *dflt;
    static char *default_old [5000], *fname_in [4], 
	*fname_out [3000], *disp_ptr;
    int in_key, number, ofst, indx, counter, start_displayed,
        curr_shown, ftn, (*ThisFtn) (), IsPrefix;
    prefix_block *ptr;

    curr_shown = start_displayed = 0;
    if (!menu)
        bzero (fname_out, 2999 * sizeof (char *));

    if (!str)
    {   if (!menu)
	{   fprintf (stderr, "BANG - win_string called in non menu");
	    fprintf (stderr, "  mode with no string\n");
	    abort ();
	}
	str = intern_str;
    }
    if (!old)
    {   if (menu)
	{   fprintf (stderr, "BANG - win_string called in menu");
	    fprintf (stderr, "  mode with no list\n");
	    abort ();
	}
	old = default_old;
    }
    dflt = NULL;
    if (menu)
    {   number = ofst = 0;
	strcpy (str, old [0]);
	stemp [0] = '\0';
    }
    else
    {   for (number = 0; old [number]; number++);
    	if (number > 0)
	{   number--;
	    strcpy (str, old [number]);
	    dflt = old [number];
	}
	else
	    *str = '\0';
	ofst = strlen (str);
    }

    do
    {   wmove (wind, y, x);
	if (ofst < start_displayed) {
	  start_displayed = ofst - 5;
	  if (start_displayed < 0)
	    start_displayed = 0;
	}
	if ((ofst + x - start_displayed) >= (COLS - 3))
	  start_displayed = x + ofst - COLS + 7;
	counter = x;
	if (start_displayed)  {
	  wstandout (wind); waddstr (wind, "+"); wstandend (wind);
	  counter++;
	}
	for (disp_ptr = &(str [start_displayed]);
	     *disp_ptr && counter < (COLS - 2);
	     disp_ptr++, counter++)
	  waddch (wind, *disp_ptr);
	if (*disp_ptr)  {
	  wstandout (wind); waddstr (wind, "+"); wstandend (wind);
	  counter++;
	}
	wclrtoeol (wind);
	if (menu && (*stemp == '*'))  {
	  waddstr (wind, "  ");
	  waddstr (wind, stemp);
	}
	else
	  wmove (wind, y, x + ofst - 
		 (start_displayed ? start_displayed - 1 : 0));
	in_key = get_key (wind);
	ThisFtn = short_cmd_pointers [in_key];
	ptr = NULL;
debug ();
	if (ThisFtn == prefix)  {
	    ptr = prefix_lookup (prefix_top, in_key);
	    do  {
		in_key = get_key (wind);
		if (ptr -> nest)
		    ptr = prefix_lookup (ptr -> nest, in_key);
	    }   while (ptr && ptr -> nest);

	    if (ptr)
		ThisFtn = ptr -> function;
        }
        ftn = -1;
        if (ptr || ((in_key < ' ') && (in_key != 0xd) &&
	   (in_key != 0xa)))
	  ftn = find_function (ThisFtn);
        if (ftn) switch (ftn) {   /*  be lazy and just trick it  */
	    case CMD_UP:
		in_key = ku;
		break;
	    case CMD_DOWN:
		in_key = kd;
		break;
	    case CMD_RIGHT:
		in_key = kr;
		break;
	    case CMD_LEFT:
		in_key = kl;
		break;
	    case CMD_HELP:
		in_key = '?' & 0x1f;
	  	break;
	    case CMD_APROPOS:
		in_key = '?' | 0x80;
	  	break;
	}
	switch (in_key)
	{   case '?' & 0x1f: /*  C-? for help  */
	        if (menu)
		    displ_help (old [number], help);
		else
		    displ_help (help, "Misc/");
		break;
	    case '?' | 0x80:  /*  M-? for apropos  */
		save_bottom ();
		apropos ();
		restore_bottom (menu);
		break;
	    case 'e' | 0x80:  /*  M-e for edit help */
	    case 'E' | 0x80:  /*  M-E for edit help */
	        if (menu)
		    edit_help (old [number], help);
		else
		    edit_help (help, "Misc/");
		break;
	    case 'A' | 0x80:  /*  M-A expand aliases  */
	    case 'a' | 0x80:  /*  M-a expand aliases  */
		strcpy (str,
			alias_expand (str, fs_aliases, fs_substitutes));
		ofst = strlen (str);
		break;
	    case 'F' | 0x80:  /*  M-F expand file names  */
	    case 'f' | 0x80:  /*  M-f expand file names  */
		if (menu)
		{   bell ();
		    break;
		}
		fname_in [0] = str;
		fname_in [1] = NULL;
		bzero (fname_out, 299 * sizeof (char *));
		name_expander (fname_in, fname_out);
		if (!*fname_out)
		{   bell ();
		    break;
		}
		while (old [number])
		    number++;
		old [number] = new_string (str);
		number++;
		for (indx = 0; fname_out [indx]; indx++)
		    old [indx + number] = fname_out [indx];
		old [indx + number] = NULL;
		strcpy (str, old [number]);
		ofst = strlen (str);
		break;
	    case 0x7f:
		if (ofst <= 0)
		    break;
		ofst--;
		if (menu)
		   stemp [ofst] = '\0';
		else 
		   strcpy (&(str [ofst]), &(str [ofst + 1]));
		break;
	    case 'U' & 0x1f:
		ofst = 0;
		if (menu)
		    stemp [0] = '\0';
		else
		    *str = '\0';
		break;
	    case '\n':
	    case '\r':
		if ((!menu) && (!dflt || (strcmp (dflt, str) != 0)))
		{   for (number = 0; old [number]; number++);
		    old [number] = new_string (str);
		}
		return (number);
		break;
	    case kd:
	    case 'N' & 0x1f:
		if (old [number + 1])
		{   number++;
		    strcpy (str, old [number]);
		    if (!menu)
			ofst = strlen (str);
		    else
		    {   ofst = 0;
			*stemp = '\0';
		    }
		}
		else
		{   if (!menu)
		    {   ofst = 0;
			*str = '\0';
			if (old [number])
			    number++;
		    }
		}
		break;
	    case ku:
	    case 'K' & 0x1f:
	    case 'P' & 0x1f:
		if (number)
		    number--;
		if (old [number])
		    strcpy (str, old [number]);
		if (!menu)
		    ofst = strlen (str);
		else
		{   ofst = 0;
		    *stemp = '\0';
		}
		break;
	    case kr:
	    case 'L' & 0x1f:
	    case 'F' & 0x1f:
		if (str [ofst])
		    ofst++;
		break;
	    case kl:
	    case 'H' & 0x1f:
	    case 'B' & 0x1f:
		if (ofst > 0)
		    ofst--;
		break;
	    case 'E' & 0x1f:
		ofst = strlen (str);
		break;
	    case 'A' & 0x1f:
		ofst = 0;
		break;
	    case 'n' | 0x80:
		if (!(*stemp == '*'))  {
		  putchar ('\007');
		  break;
		}
		number = found [++curr_shown];
		if (number < 0)  {
		  number = found [--curr_shown];
		  putchar ('\007');
		}
		strcpy (str, old [number]);
		break;
	    case 'p' | 0x80:
		if (!(*stemp == '*'))  {
		  putchar ('\007');
		  break;
		}
		if (!curr_shown)  {
		  putchar ('\007');
		  break;
		}
		number = found [--curr_shown];
		strcpy (str, old [number]);
		break;
	    default:
		if (menu)
		{   stemp [ofst] = uc_char (in_key);
		    ofst++;
		    stemp [ofst] = '\0';
		    complete (stemp, str, old, &number, &ofst);
		    curr_shown = 0;
		}
		else
		{   if (in_key >= ' ')
		    {   strcpy (stemp, &(str [ofst]));
			str [ofst] = in_key;
			strcpy (&(str [ofst + 1]), stemp);
			str [ofst] = in_key;
			ofst++;
		    }
		    else
			putchar ('\07');
		}
	}
    }   while (1);
    return (0);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

char ignorecase[0400] = 
  { 000, 001, 002, 003, 004, 005, 006, 007,
    010, 011, 012, 013, 014, 015, 016, 017,
    020, 021, 022, 023, 024, 025, 026, 027,
    030, 031, 032, 033, 034, 035, 036, 037,
    040, 041, 042, 043, 044, 045, 046, 047,
    050, 051, 052, 053, 054, 040, 056, 057,
    060, 061, 062, 063, 064, 065, 066, 067,
    070, 071, 072, 073, 074, 075, 076, 077,
    0100, 0101, 0102, 0103, 0104, 0105, 0106, 0107,
    0110, 0111, 0112, 0113, 0114, 0115, 0116, 0117,
    0120, 0121, 0122, 0123, 0124, 0125, 0126, 0127,
    0130, 0131, 0132, 0133, 0134, 0135, 0136, 0137,
    0140, 0101, 0102, 0103, 0104, 0105, 0106, 0107,
    0110, 0111, 0112, 0113, 0114, 0115, 0116, 0117,
    0120, 0121, 0122, 0123, 0124, 0125, 0126, 0127,
    0130, 0131, 0132, 0173, 0174, 0175, 0176, 0177,
    0200, 0201, 0202, 0203, 0204, 0205, 0206, 0207,
    0210, 0211, 0212, 0213, 0214, 0215, 0216, 0217,
    0220, 0221, 0222, 0223, 0224, 0225, 0226, 0227,
    0230, 0231, 0232, 0233, 0234, 0235, 0236, 0237,
    0240, 0241, 0242, 0243, 0244, 0245, 0246, 0247,
    0250, 0251, 0252, 0253, 0254, 0255, 0256, 0257,
    0260, 0261, 0262, 0263, 0264, 0265, 0266, 0267,
    0270, 0271, 0272, 0273, 0274, 0275, 0276, 0277,
    0300, 0301, 0302, 0303, 0304, 0305, 0306, 0307,
    0310, 0311, 0312, 0313, 0314, 0315, 0316, 0317,
    0320, 0321, 0322, 0323, 0324, 0325, 0326, 0327,
    0330, 0331, 0332, 0333, 0334, 0335, 0336, 0337,
    0340, 0341, 0342, 0343, 0344, 0345, 0346, 0347,
    0350, 0351, 0352, 0353, 0354, 0355, 0356, 0357,
    0360, 0361, 0362, 0363, 0364, 0365, 0366, 0367,
    0370, 0371, 0372, 0373, 0374, 0375, 0376, 0377
  };

Jstrncmp (a, b, len)
char *a, *b;
int len;
{   int dif;

    for (len; len && *a && *b; len--, a++, b++)
        if (dif = (ignorecase [*a] - ignorecase [*b]))
	    return (dif);
    return (len);
}

Jstrcmp (a, b)
char *a, *b;
{   int dif;

    for (; *a && *b; a++, b++)
        if (dif = (ignorecase [*a] - ignorecase [*b]))
	    return (dif);
    return ((int) (ignorecase [*a] - ignorecase [*b]));
}

complete (string, displ, list, number, ofst)
char *string, *displ, **list;
int *number, *ofst;
{   int indx, len, ch_index, match;
    int num_found;
    char *star, *search_for, *start;

    found [0] = found [1] = -1;
    num_found = 0;
    if (star = index (string, '*'))  {
      strcpy (found, star);
      strcpy (string, found);
      search_for = string + 1;
      len = strlen (search_for);
      if (!len)
	return;
    }
    else
      len = strlen (string);
    for (indx = 0; list [indx]; indx++)
    {   if (star)  {
           for (start = list [indx];
		*start && Jstrncmp (start, search_for, len);
		start++);
	   if (*start)
	     found [num_found++] = indx;
        }
	else if (Jstrncmp (list [indx], string, len) == 0)
	    found [num_found++] = indx;
    }
    found [num_found] = -1;  /*  tie it off  */
    switch (num_found)
    {   case 0:
	    putchar ('\07');
	    *ofst = 0;
	    string [0] = 0;
	    break;
	case 1:
	    *number = found [0];
	    strcpy (displ, list [found [0]]);
	    break;
	default:
	    strcpy (displ, string);
	    if (star)  {
	      strcpy (displ, list [found [0]]);
	      *number = found [0];
	      break;
	    }
	    if (!incremental_complete)
	    {   *ofst = strlen (displ);
		strcpy (displ, list [*number = found [0]]);
		break;
	    }
	    match = 1;
	    for (ch_index = len;
		(ch_index < strlen (list [found [0]])) && match;
		ch_index++)
	    {   match = 1;
		for (indx = 1; indx < num_found; indx++)
		    match &= (
			ignorecase [list [found [indx]][ch_index]] ==
		        ignorecase [list [found [0]][ch_index]]);
		if (match)
		{   displ [ch_index] = list [found [0]][ch_index];
		    string [ch_index] = displ [ch_index];
		    *ofst = match;
		    displ [ch_index + 1] = 0;
		    string [ch_index + 1] = 0;
		}
	    }
	    *ofst = strlen (displ);
	    strcpy (displ, list [*number = found [0]]);
    }
}


intro_aliases (aliases, substitutes)
char **aliases, **substitutes;
{   fs_aliases = aliases;
    fs_substitutes = substitutes;
}

find_function (f)
int (*f) ();
{
    if (f == cmd_up)
	return (CMD_UP);
    if (f == cmd_down)
	return (CMD_DOWN);
    if (f == cmd_left)
	return (CMD_LEFT);
    if (f == cmd_right)
	return (CMD_RIGHT);
    if (f == cmd_help)
	return (CMD_HELP);
    if (f == cmd_apropos)
	return (CMD_APROPOS);
    return 0;
}

