// changed usg to linux // Mike Jurka 2003
// meta changed to metaMASE b/c of conflicts // Mike Jurka 2003
#ifndef LINT
static char *sccs_sid = "@(#)kbd.c	2.3 4/5/89 WINLIB";
#endif

#ifdef sparc
#include <termios.h>
#else
#include <sys/ioctl.h>
#endif

//#ifdef linux
//#include <sys/filio.h>
//#endif

#include "curses.h"
#include "config.h"
#include <signal.h>

#include <stdio.h> // Mike Jurka 2003

#ifdef linux
WINDOW **refresh_list = NULL;
WINDOW **refr_tmp;
#endif

unsigned char metaMASE, literal;

void (*fnc) ();  /*  remember SIGINT handler for ``tty_mode''  */

unsigned char *macro_list [256], *macro_stack [256];

unsigned char current_key;

#include "extern.h"

input_pending ()
/*  returns true if there seems to be some input pending  */
{   int in_q;
    FILE *inp;

    inp = stdin;
    in_q = (inp->_IO_write_end - inp->_IO_write_ptr) > 0 ? 0 : inp->_IO_write_end - inp->_IO_write_ptr; // Mike Jurka 2003, for linux i/o compat

    if (in_q > 0)   /* pending input if stdin -> _cnt  */
	return (1);

/*  berkley  */
    if (ioctl (0, FIONREAD, &in_q) == -1) 
	return (0);  /*  don't know what happened  */
    return ((in_q > 0) ? 1 : 0);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unsigned char get_key (win)
WINDOW *win;
/*  returns one "logical" key stroke from kbd - returns
    key or ku, kd, kr, kl
    references meta_next, literal_next, and the key remapping
    buffers
*/
/*ENDDOC*/
{   int indx, x, y;
    extern int is_a_ttyin;
    unsigned char in_ch;
    char stemp [200];

    if (!macro_stack [0] && !input_pending ())
    {   
#ifdef linux
	if (refresh_list)
	    for (refr_tmp = refresh_list; *refr_tmp; refr_tmp++)  {
		leaveok (*refr_tmp, 1);
		wnoutrefresh (*refr_tmp);
		leaveok (*refr_tmp, 0);
	    }
#endif
	if (win != stdscr)
	{   leaveok (stdscr, 1);
#ifdef linux
	    wnoutrefresh (stdscr);
#else
	    wrefresh (stdscr);
#endif
	    leaveok (stdscr, 0);
	}
#ifdef linux
	wnoutrefresh (win);
	doupdate ();
#else
	wrefresh (win);
#endif
    }
    if (macro_stack [0])
    {	while (macro_stack [0] && (*macro_stack [0] == '\0'))
	{   for (indx = 0; macro_stack [indx]; indx++)
		macro_stack [indx] = macro_stack [indx + 1];
	}
	if (macro_stack [0])
	{   in_ch = *macro_stack [0];
	    (macro_stack [0])++;
	}
	else
	{   if (!input_pending ())
	    {   
#ifdef linux
		if (refresh_list)
		    for (refr_tmp = refresh_list; *refr_tmp; refr_tmp++)
			wrefresh (*refr_tmp);
#endif
		if (win != stdscr)
		{   leaveok (stdscr, 1);
		    refresh ();
		    leaveok (stdscr, 0);
		}
		wrefresh (win);
	    }
#ifdef linux
	    if ((in_ch = getchar ()) == -1)  {
		siginterrupt (SIGINT, 1);
		siginterrupt (SIGSTOP, 1);
		siginterrupt (SIGTSTP, 1);
		return (get_key (win));
	    }
#else usg
	    in_ch = wgetch (win);
#endif linux
	}
    }
    else
    {
#ifdef linux
	    if ((in_ch = getchar ()) == -1)  {
		siginterrupt (SIGINT, 1);
		siginterrupt (SIGSTOP, 1);
		siginterrupt (SIGTSTP, 1);
		return (get_key (win));
	    }
#else usg
	    in_ch = wgetch (win);
#endif linux
    }
#ifdef linux
    if (in_ch == -1)  {
	clearerr (stdin);
	clearerr (stdout);
    }
#endif
    in_ch |= metaMASE;
    metaMASE = 0;
    if (!literal)
    {   if (short_cmd_pointers [in_ch] == meta_next)
	{   metaMASE = 0x80;
	    return (get_key (win));
	}
        if (short_cmd_pointers [in_ch] == literal_next)
	{   literal = 1;
	    return (get_key (win));
	}
	if (macro_list [in_ch])
	{   /*  push it up  */
	    for (indx = 0; macro_stack [indx]; indx++);
	    if (indx >= MAX_NUM_MACROS)
	    {   for (indx = 0; indx < MAX_NUM_MACROS; indx++)
		    macro_stack [indx] = NULL;
		move (LINES - 2, 0);
		printw ("PANIC - mapping expansion exceded %d ", 
		    MAX_NUM_MACROS);
		addstr ("levels - aborted");
		Pause (1);
		clean_bottom ();
		move (LINES - 2, 0);
		sprintf (stemp, 
	 	    "Removing mapping for character 0x%x, '%c'",
		    in_ch, in_ch);
		addstr (stemp);
		free (macro_list [in_ch]);
		macro_list [in_ch] = NULL;
		Pause (1);
		clean_bottom ();
		return (get_key (win));
	    }
	    for (; indx >= 0; indx--)
		macro_stack [indx + 1] = macro_stack [indx];
	    macro_stack [0] = macro_list [in_ch];
	    return (get_key (win));
	}
    }
    literal = 0;
    return (in_ch);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

/*STARTDOC*/
Pause (level)
int level;
/*  wait for user acknowlegment.
    if this session is not ``interactive'',
	and level != 0, then it will force a ``crash''
    (good for batch mode)
*/
/*ENDDOC*/
{   int x, y, chr;
    extern int interactive;

    clrtoeol ();
    if (!interactive)
    {   refresh ();
	if (level)
	{   move (LINES - 1, 0);
	    addstr ("Fatal error for batch mode");
	    refresh ();
	    endwin ();
	    exit (1);
	}
	return;
    }

    getyx (stdscr, y, x);
    move (LINES - 1, 0);
    addstr ("Hit <CR> to continue -> ");
    clrtoeol ();
    refresh ();

    do
    {   chr = getchar ();
    }   while ((chr != '\n') && (chr != '\r'));

    move (LINES - 1, 0);
    clrtoeol ();
    move (y, x);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */

#ifndef linux
static struct sgttyb buf;
static int old_flags;
#endif
/*STARTDOC*/
tty_mode ()
/*  set terminal modes for glass tty  */
/*ENDDOC*/
{  
#ifdef linux
    def_prog_mode ();
    reset_shell_mode ();
    move (LINES - 0, 0);
    refresh ();
    printf ("\n\n");
#else
    echo ();
    ioctl (0, TIOCGETP, &buf);
    old_flags = buf.sg_flags;
    buf.sg_flags &= (~CBREAK & ~RAW);
    ioctl (0, TIOCSETP, &buf);
    if (TE)
	fputs (TE, stdout);
    if (VE)
	fputs (VE, stdout);
    if (CL)
	fputs (CL, stdout);
    if (HO)
	fputs (HO, stdout);
    fflush (stdout);
#endif
    fnc = signal (SIGINT, SIG_IGN);
#ifdef linux
    siginterrupt (SIGINT, SIG_IGN);
#endif linux

    return;
}

/*STARTDOC*/
full_screen_mode ()
/*  put terminal modes back for full screen  */
/*ENDDOC*/
{
#ifdef linux
    reset_prog_mode ();
#else
    if (TI)
	fputs (TI, stdout);
    if (VS)
	fputs (VS, stdout);
    fflush (stdout);
    buf.sg_flags = old_flags;
    ioctl (0, TIOCSETP, &buf);
    noecho ();
#endif
    wrefresh (curscr);
    if (fnc)
	signal (SIGINT, fnc);
    else 
	signal (SIGINT, SIG_DFL);
#ifdef linux
    siginterrupt (SIGINT, 1);
#endif linux
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
int meta_next ()
/*  next character is to be metasized  */
/*ENDDOC*/
{   metaMASE = 0x80;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
int literal_next ()
/*  next character is not to be macro-expanded  */
/*ENDDOC*/
{   literal = 1;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
clean_bottom ()
/*  erase the bottom of the screen  */
/*ENDDOC*/
{   move (LINES - 2, 0);
    clrtobot ();
}


