#ifndef LINT
static char *sccs_sid = "@(#)mapping.c	2.5 4/25/89 WINLIB";
#endif

#include "curses.h"
#include "extern.h"
#include "win-types.h"
#define MAX_MAP_EXPANSION 4000



static macro_recurse ();

prefix_block *new_prefix ()
{   prefix_block *b;

    b = (prefix_block *) ecalloc (1, sizeof (prefix_block));
    return (b);

}

prefix_block *insert_prefix (top, k)
prefix_block *top;
unsigned char k;
{   prefix_block *last, *new;

    if (!top)
        return (NULL);
    while (top && ((top -> letter) < k))  {
        last = top;
        top = top -> next;
    }
    if (top && ((top -> letter) == k))
        return top;
    new = new_prefix ();
    if (top)  {
        new -> next = top;
	new -> previous = top -> previous;
	top -> previous = new;
	new -> previous -> next = new;
    }
    else  {
        last -> next = new;
	new -> previous = last;
    }
    new -> letter = k;
    return (new);
}

prefix_block *prefix_lookup (ptr, key)
prefix_block *ptr;
unsigned char key;
{   
    if (!ptr)
        return (NULL);

    while (ptr)  {
	if (ptr -> letter == key)
	    return (ptr);
	ptr = ptr -> next;
    }
    return (NULL);
}


prefix (a, b, c)  /*  just a hook to bind to  */
int *a, *b, c;
{   unsigned char key;
    prefix_block *ptr;
    static int in_prefix = 0;
    
    if (!in_prefix) {
        in_prefix = 1;
        move (LINES - 1, 0);
    }
    ascii_print (current_key);
    key = current_key;
    ptr = prefix_lookup (prefix_top, key);

    if (!ptr || !ptr -> nest)  {
	putchar (7);
	in_prefix = 0;
	return;
    }
    ptr = ptr -> nest;

    do  {
	current_key = key = get_key (stdscr);
	ascii_print (key);
	ptr = prefix_lookup (ptr, key);
	if (!ptr)  {
	    putchar (7);
	    in_prefix = 0;
	    return;
	}
	if (!(ptr -> nest)) {
	    if (ptr -> function)  {
		in_prefix = 0;
		return ((ptr -> function) (a, b, c));
	    }
	    else  {
		putchar (7);
		in_prefix = 0;
		return;
	    }
	}
	ptr = ptr -> nest;
    }   while (1);
    in_prefix = 0;
}


/*STARTDOC*/
static int bell ()
/*  what else ???  */
/*ENDDOC*/
{   putchar ('\007');
    fflush (stdout);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
map ()
/*  interactively establish a key macro mapping  */
/*ENDDOC*/
{   char stemp [200], *ptr;
    unsigned char key;

    move (LINES - 2, 0);
    addstr ("Key to map -> ");
    clrtoeol ();
    key = get_key (stdscr);
    move (LINES - 2, 0);
    addstr ("String to map it to (terminate with ^@ -> ");
    clrtoeol ();

    for (ptr = stemp; *ptr = (char) get_key (stdscr); ptr++);
    do_map ((unsigned char) key, (unsigned char *) stemp);
}   

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
do_map (key, stemp)
/*  set ``key'' code to be remapped into ``stemp''  */
/*ENDDOC*/
unsigned char key, *stemp;
{   if (macro_list [key])
	free (macro_list [key]);
    if (stemp)
	macro_list [key] = (unsigned char *) new_string (stemp);
    else
	macro_list [key] = NULL;
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*ENDDOC*/
bind ()
/*  interactively bind a key to a function  */
/*ENDDOC*/
{   char stemp [200];
    unsigned key, key2;
    int ftn, IsPrefix;
    prefix_block *ptr, *old_ptr;

    IsPrefix = 0;
    move (LINES - 2, 0);
    addstr ("Key to bind -> ");
    clrtoeol ();
    key = get_key (stdscr);
    ascii_print (key);
    if (short_cmd_pointers [key] == prefix)  {
	IsPrefix = 1;
	ptr = prefix_lookup (prefix_top, key);
	if (!ptr)  {
	    printw (" NO PREFIX");
	    putchar (7);
	    Pause (0);
	}
	do  {
	    old_ptr = ptr;
	    key = get_key (stdscr);
	    ascii_print (key);
	    if (ptr -> nest)
		ptr = prefix_lookup (ptr -> nest, key);
	}   while (ptr && (ptr -> nest));
	if (!ptr)
	    ptr = insert_prefix (old_ptr -> nest, key);
    }
    if (ftn = win_prompt (stdscr, LINES - 2, "Function to bind it to",
	stemp, long_cmd_names, 1, "Functions/"))  {
	if (IsPrefix)  {
	   ptr -> function = long_cmd_pointers [ftn];
	}
	else  {
	short_cmd_pointers [key] = long_cmd_pointers [ftn];
	}
	if (long_cmd_pointers [ftn] == prefix)  {
	    if (!IsPrefix)
		ptr = insert_prefix (prefix_top, key);
	    ptr -> function = prefix;
	    ptr -> nest = new_prefix ();
	    ptr = ptr -> nest;
	}
    }
}   

ascii_print (k)
unsigned char k;
{
    if (k >= 128)  {
        addstr ("M-");
	k &= 0x7f;
    }
    if ((k >= '!') && (k <= '~')) {
	addch (k);
    }
    else {
        switch (k)  {
	   case ' ':
	        addstr ("<SPACE>");
		break;
	   case 0x1b:
		addstr ("<ESC>");
		break;
	   case 0x7f:
		addstr ("<DEL>");
		break;
	   default:
		addstr ("C-");
	        addch (k + '@');
        }
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

e_printf (fmt, arg1, arg2, arg3, arg4, arg5)
char *fmt, *arg1, *arg2, *arg3, *arg4, *arg5;
{   char yuk [200];

    if (stdscr)
    {   move (LINES - 2, 0);
	sprintf (yuk, fmt, arg1, arg2, arg3, arg4, arg5);
	addstr (yuk);
	Pause (0);
    }
    else
    {   fprintf (stderr, fmt, arg1, arg2, arg3, arg4, arg5);
	get_response (yuk, "Hit <CR> to continue -> ", "x");
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
text_map (map_chr, string)
unsigned char *map_chr, *string;
/*  establish so tha key code indicated by the ``map_chr'' string
    should be macro mapped into ``string''
*/
/*ENDDOC*/
{   
    if (!*map_chr || !*string)
	return;
    if (macro_list [*map_chr])
	free (macro_list [*map_chr]);
    macro_list [*map_chr] = (unsigned char *) new_string (string);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
text_bind (mchr, ftn)
unsigned char *mchr;
char *ftn;
/*  set it up so that key indicated by string ``mchr'' will
    bound to ``ftn''
*/
/*ENDDOC*/
{   
    if (!*mchr || !*ftn)
	return;
    uc_string (ftn);
    do_bind (mchr, ftn);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   


/*STARTDOC*/
do_bind (chr, ftn_name)
unsigned char *chr;
char *ftn_name;
/*  establish binding for ``chr'' key code to ``fnt_name''  */
/*ENDDOC*/
{   int indx;
    int (*ftn) ();
    prefix_block *ptr, *last;

    switch (indx = svdecode (ftn_name, long_cmd_names))
    {   case -2:   /*  not found  */
            e_printf ("Function \"%s\" unknown", ftn_name);
	    break;
        case -1:   /*  ambiguous  */
	    e_printf ("Function \"%s\" ambiguous", ftn_name);
	    break;
	default:
	    ftn = long_cmd_pointers [indx];
	    if (!chr [1])  {
	        short_cmd_pointers [*chr] = ftn;
		if (ftn == prefix)  {
		    ptr = insert_prefix (prefix_top, *chr);
		    ptr -> nest = new_prefix ();
		}
	    }   else
	    {   if (short_cmd_pointers [*chr] != prefix)  {
	            short_cmd_pointers [*chr] = prefix;
		    ptr = insert_prefix (prefix_top, *chr);
		    ptr -> function = prefix;
		    ptr -> nest = new_prefix ();
		    ptr = ptr -> nest;
	        }
		ptr = prefix_top;
		while (chr [1])  {
		    last = ptr;
		    ptr = prefix_lookup (ptr, *chr);
		    if (!ptr)
		        ptr = insert_prefix (last, *chr);
		    if (!ptr -> nest)
		        ptr -> nest = new_prefix ();
		    ptr -> function = prefix;
		    ptr = ptr -> nest;
		    chr++;
		}
		ptr = insert_prefix (ptr, *chr);
		ptr -> function = ftn;
	    }
      	    break;
    }
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unbind ()
/*  remove all bindings - then bind ``:'' to ``command-mode''  */
/*ENDDOC*/
{   int indx;

    for (indx = 0; indx < 256; indx++)
	short_cmd_pointers [indx] =  bell;

    do_bind (":", "COMMAND-MODE");
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unbind_alpha ()
/*  remove all alphabetic bindings  */
/*ENDDOC*/
{   int indx;

    for (indx = 'A'; indx <= 'Z'; indx++)
	short_cmd_pointers [indx] =  bell;
    for (indx = 'a'; indx <= 'z'; indx++)
	short_cmd_pointers [indx] =  bell;
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unmap_alpha ()
/*  remove all alphabetic macro maps  */
/*ENDDOC*/
{   int indx;

    for (indx = 'A'; indx < 'Z'; indx++)
	if (macro_list [indx])
	{   free (macro_list [indx]);
	    macro_list [indx] = NULL;
	}
    for (indx = 'a'; indx < 'z'; indx++)
	if (macro_list [indx])
	{   free (macro_list [indx]);
	    macro_list [indx] = NULL;
	}
    move (LINES - 2, 0);
    addstr ("Alphabetic mappings released.");
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unmap ()
/*  remove all macro maps  - -  may inactivate cursors  */
/*ENDDOC*/
{   int indx;

    for (indx = 0; indx < 256; indx++)
	if (macro_list [indx])
	{   free (macro_list [indx]);
	    macro_list [indx] = NULL;
	}
    move (LINES - 2, 0);
    addstr ("All mappings released.");
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/*STARTDOC*/
unsigned char *mapping_decode (c)
unsigned char c;
/*  Return macro-expansion of character ``c'' - fully recursive 
    return string is pointer to static space
*/
/*ENDDOC*/
{   static unsigned char buf [MAX_MAP_EXPANSION];
    unsigned char *ptr, tmp [3];

    tmp [0] = c;
    tmp [1] = '\0';
    ptr = buf;
    macro_recurse (&ptr, tmp, 0);
    return (buf);
}

static macro_recurse (pleft, right, level)
unsigned char **pleft, *right;
int level;
{   unsigned char *string;

    if (level > 10)  {
        move (LINES - 2, 0);
	printw ("INFINITE RECURSION OF MACRO");
	Pause (1);
	*pleft = '\0';
	return;
    }

    for (; *right; right++)
      if (string = macro_list [*right])
	macro_recurse (pleft, string, level + 1);
      else
	*((*pleft)++) = *right;

    **pleft = '\0';
}

