#ifndef LINT
static char *sccs_sid = "@(#)align.c      1.1 6/09/97 MASE";
#endif

#include "edseq.h"
#include "extern.h"
#include "../lib/faulkn.h"
#include <string.h>

/*#define DEBUG*/

#define min(x, y)        (((x) < (y)) ? (x) : (y))
#if 0
char *eac_history [] = { "vmaln2 1> /dev/null 2>&1",
                         "clustalig 1> /dev/null 2>&1",
                         NULL, NULL, NULL };
int eac = 0;
char external_alignment_call [200] = "vmaln2 1> /dev/null 2>&1";
#endif
char *eac_history [] = { "vmaln2",
                         "clustalig",
                         NULL, NULL, NULL };
int eac = 0;
char external_alignment_call [200] = "vmaln2";

char *eaa_history [] = { "Allison-Yee (Milosavljevic)",
                         "Waterman-Smith (Monardo)",
                         "Needleman-Wunsch (Myers)",
                         "SWAT",
                         NULL, NULL, NULL };
int eaa = 2;
char external_alignment_algorithm [200] = "Needleman-Wunsch (Myers)";

char *eam_history [] = { "/usr/local/lib/mat/xrepmask.mat",
                         "/usr/local/lib/mat/xdna.mat",
                         "/usr/local/lib/mat/xmirl.mat",
                         NULL, NULL, NULL };
int eam = 0;
char external_alignment_matrix [200] = "/usr/local/lib/mat/xrepmask.mat";

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

/* (PWK) 08/15/96 */
eac_verify ()
{   int indx;
 
    for (indx = 2; eac_history [indx]; indx++)  {
        free (eac_history [indx]);
        eac_history [indx] = NULL;
    }
    switch (eac = svdecode (external_alignment_call, eac_history))  {
        case 0:
        case 1:
            break;
        default:
            eac = win_prompt (stdscr, LINES - 2, 
                "External Alignment Call",
                external_alignment_call, eac_history, 1, "EAC/");
            break;
    }
    strcpy (external_alignment_call, eac_history [eac]);
}

/* (PWK) 08/15/96 */
eaa_verify ()
{   int indx;
 
    for (indx = 4; eaa_history [indx]; indx++)  {
        free (eaa_history [indx]);
        eaa_history [indx] = NULL;
    }
    switch (eaa = svdecode (external_alignment_algorithm, eaa_history))  {
        case 0:
        case 1:
        case 2:
        case 3:
            break;
        default:
            eaa = win_prompt (stdscr, LINES - 2, 
                              "External Alignment Call",
                              external_alignment_algorithm,
                              eaa_history, 1, "EAA/");
            break;
    }
    strcpy (external_alignment_algorithm, eaa_history [eaa]);
}

/* (PWK) 06/09/97 */
eam_verify ()
{   int indx;
 
    for (indx = 3; eam_history [indx]; indx++)  {
        free (eam_history [indx]);
        eam_history [indx] = NULL;
    }
    switch (eam = svdecode (external_alignment_matrix, eam_history))  {
        case 0:
        case 1:
        case 2:
            break;
        default:
            eaa = win_prompt (stdscr, LINES - 2, 
                              "SWAT Alignment Matrix",
                              external_alignment_matrix,
                              eam_history, 1, "EAM/");
            break;
    }
    strcpy (external_alignment_matrix, eam_history [eam]);
}

/* (PWK) 07/25/96 */
extern_align (current_y, current_x)
int *current_x, *current_y;  /*  zero based  */
{   int *sq_list, indx, last, len;
    char stemp [200], *range_list = { NULL };

    win_prompt (stdscr, LINES - 2, 
                "Align which sequences", stemp, range_list, 0, "Range");
    if (!(sq_list = string_to_numbers (stemp)))
      return;

    move (LINES - 2, 0);
    printw ("Aligning ... \n");
    clrtoeol ();
    refresh();

    last = 0;
    for (indx = 0; indx < num_entries; indx++) {
      len = entry [indx] -> length;
      if (len > last)
        last = len;
    }

    do_align(0, last, sq_list);
    free (sq_list);
}

extern_align_part (current_y, current_x, mult)
int *current_x, *current_y;  /*  zero based  */
{   int *sq_list, first, last;
    char stemp [200], stemp2 [200], *range_list [10] = { NULL };

    win_prompt (stdscr, LINES - 2, 
                "Align which sequences", stemp, range_list, 0, "Range");
    if (!(sq_list = string_to_numbers (stemp)))
      return;

    sprintf (stemp2, "%d", *current_x + 1);
    if (range_list [1])
      free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
      free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
                "    Start at position", stemp, range_list, 0, "SqStart");
    sscanf (stemp, "%d", &first); first--;

    sprintf (stemp2, "%d", first + 1 + mult);
    if (range_list [1])
      free (range_list [1]);
    range_list [1] = NULL;
    if (range_list [0])
      free (range_list [0]);
    range_list [0] = stemp2;
    win_prompt (stdscr, LINES - 2,
                "    End at position", stemp, range_list, 0, "SqEnd");
    sscanf (stemp, "%d", &last);

    move (LINES - 2, 0);
    printw ("Aligning from %d to %d ... \n", first + 1, last);
    clrtoeol ();
    refresh();

    do_align(first, last, sq_list);
    free (sq_list);
}

#define FORWARD 1
#define BACKWARD -1

do_align(r_start, r_end, sq_list)
int r_start, r_end;
int *sq_list;
{   int save_protect;
    int indx, indx2, conty, i;
    int r_start2, r_end2;
    int *tmp, *tmp2, *num, *num2;
    sq *which, *tmpsq, *rd_next ();
    char *tmpseq1, *tmpseq2, *s1, *s2;
    char *tmpseq3;
    int lens1, lens2;
    FILE *fout, *fin;
    char foutname [10] = "_aln.tmp", finname [10] = "_aln.out";
    char finnameimg [16] = "_aln.out.image";
    char *p_end, *ptr;
    char stemp[200];
    static char *history [200];
    extern char mod_string [];
    extern compensate (), create_anchor (), sync_anchor2 (), strip_anchor2 ();
    extern sq *rd_next_add_anchors ();
    char syscmd[200];
    FILE *paln;
#ifdef DEBUG
    FILE *dbg;
#endif

#if 0
    /* For "restricted" alignment, first we set our anchors: */
    /*create_anchor(r_start);*/
    for (indx = 0; indx < num_entries; indx++) {
      if (r_start < entry [indx] -> length)
        ins_1 (indx, r_start, 1, '.');
      else
        ins_1 (indx, entry [indx] -> length, 1, '.');
    }
    r_start++;
    r_end++;
    /*create_anchor(r_end);*/
    for (indx = 0; indx < num_entries; indx++) {
      if (r_end < entry [indx] -> length)
        ins_1 (indx, r_end, 1, '.');
      else
        ins_1 (indx, entry [indx] -> length, 1, '.');
    }
    /* r_end++; */
    dirty_x = dirty_y = 1;
#endif

    make_mod_string ();
    /* *finname = '\0'; */
    fout = w_open_file (foutname, "w", history);

    /* save region to file */
    for (tmp = sq_list; *tmp >= 0; tmp++)  {
      which = entry [*tmp - 1];

      /* make sure the fragments we are saving contain no gaps, as some
         alignment algorithms don't handle these sequences gracefulkly */
      conty = 1;
      indx2 = 0;
      for (indx = r_start; conty && (indx < r_end); indx++)
      {	  switch (which -> seq[indx])
          {   case '\0':
                conty = 0;
                break;
              case '-':
                break;
              default:
                indx2++;
                break;
          }
      }
      if (indx2 <= 0) {
        /* remove "all-gap" entry from sq_list by shifting all elements
           over, and overwriting the current one */
        for (tmp2 = tmp; *tmp2 >= 0; tmp2++)
          *tmp2 = *(tmp2 + 1);
        tmp--; /* it will be incremented at top of loop */
      } else {
        fputs (which -> comments, fout);
        if (which -> modified)
          fputs (mod_string, fout);
        fprintf (fout, "; Region %d to %d, from file %s\n",
                 r_start + 1, r_end, which -> from_file);
        fprintf (fout, "%s\n", which -> locus_name);
        p_end = &(which -> seq) [r_end];
        indx = 0;
        for (ptr = &(which -> seq) [r_start]; *ptr && ptr < p_end; ptr++)  {
          if (!(indx % sequence_line_length) && indx)
            putc ('\n', fout);
          putc (*ptr, fout);
          indx++;
        }
        putc ('\n', fout);
        fflush (fout);
      }
    }
    fclose (fout);
  
    /* CALL ALIGNMENT ALGORITHM WITH *finname, *foutname */
    switch (eac) {
        case 0: /* for vmaln2 */
        {
            sprintf(syscmd, "%s 1> /dev/null 2>&1", eac_history[eac]);
            /* paln = popen (eac_history[eac], "w"); */
            paln = popen (syscmd, "w");
            fprintf (paln, "n\n");
            fprintf (paln, "%s\n", foutname);
            fprintf (paln, "\n");
            fprintf (paln, "%s\n", foutname);
            fprintf (paln, "%s\n", finname);
            if (eaa >= 3) {
                /* for SWAT (Hein align is skipped) */
                fprintf (paln, "%d\n", eaa + 2);
                fprintf (paln, "%s\n", external_alignment_matrix);
            } else
                fprintf (paln, "%d\n", eaa + 1);
            fprintf (paln, "/dev/null\n");
            pclose (paln);
            break;
        }
        case 1: /* for clustalig */
        {
            sprintf(syscmd, "%s %s %s 1> /dev/null 2>&1", eac_history[eac],
                    foutname, finname);
            system(syscmd);
            break;
        }
        default:
            break;
    }

#ifndef DEBUG
    unlink(foutname);
#endif
    /* READ IN NEW ALIGNMENT *foutname */
    /* and OVERWRITE AREA OF PREVIOUS ALIGNMENT WITH NEW */
    save_protect = protect;
    protect = 0; /*  turn off protect to override  */
    fin = w_open_file (finname, "r", history);
    if (eac == 0)
      tmpsq = rd_next (fin); /* if vmaln2 skip first seq. */

#ifdef DEBUG
    dbg = fopen("DBG", "w");
#endif
    move (LINES - 2, 0);
    printw ("Reading \"%s\"", finname);
    clrtoeol ();
    refresh ();
    num = sq_list;
    r_start2 = r_start;
    lens1 = lens2 = 0;
    while ((tmpsq = rd_next_add_anchors (fin)) && *num > 0) {
      strcpy (tmpsq -> from_file, finname);
      if (!silent)
      {   move (LINES - 2, 40);
          sprintf (stemp, "\"%-20s\", %7d", tmpsq -> locus_name,
                   tmpsq -> length);
          addstr (stemp);
          clrtoeol ();
          refresh ();
      }

      /* Alignment sometimes eliminates (cuts off) the ends,
         they must be restored! */
      tmpseq1 = ecalloc (tmpsq -> length + 1, 1);
      conty = 1;
      indx2 = 0;
      for (indx = 0; conty; indx++)
      {	  switch (tmpsq -> seq[indx])
          {   case '\0':
                conty = 0;
                break;
              case '-':
                break;
              default:
                tmpseq1[indx2] = tmpsq -> seq[indx];
                indx2++;
                break;
          }
      }
      tmpseq1[indx2] = '\0';

      tmpseq2 = ecalloc (r_end - r_start + 1, 1);
      conty = 1;
      indx2 = 0;
      for (indx = r_start; conty && (indx < r_end); indx++)
      {	  switch (entry[*num - 1] -> seq[indx])
          {   case '\0':
                conty = 0;
                break;
              case '-':
                break;
              default:
                tmpseq2[indx2] = entry[*num - 1] -> seq[indx];
                /* Since vmaln2 returns alignments in uppercase ??? */
                tmpseq2[indx2] = uc_char(tmpseq2[indx2]);
                indx2++;
                break;
          }
      }
      tmpseq2[indx2] = '\0';
#ifdef DEBUG
      fprintf(dbg, "%s %d %d %d\n", entry[*num - 1] -> locus_name,
              r_start, r_end, entry[*num - 1] -> length); 
      fflush(dbg);
#endif
      /* r_end2 = min (r_end, entry[*num - 1] -> length); */
      r_end2 = r_end;
      /* r_end2 = r_end + strlen(tmpseq1) - strlen(tmpseq2); */
#ifdef DEBUG
      fprintf(dbg, "%d %d %d %d\n", *num - 1, r_start, r_start2,
              r_end, r_end2);
      fprintf(dbg, "[%s]\n", tmpsq -> seq);
      fprintf(dbg, "[%s]\n", tmpseq1);
      fprintf(dbg, "[%s]\n", tmpseq2);
      fflush(dbg);
#endif
      /* first part */
      /*s1 = strstr (tmpseq2, tmpseq1);*/
      /* skip anchor */
      tmpseq3 = tmpseq1 + 1;
      tmpseq3[strlen(tmpseq3)-1] = '\0';
      s1 = strstr (tmpseq2, tmpseq3);
#ifdef DEBUG
      fprintf(dbg, "[%s]\n", tmpseq3);
      if (s1 && *s1)
        fprintf(dbg, "s1 = [%s]\n", s1);
      fflush(dbg);
#endif
      /* last part */
      /*s2 = s1 + strlen(tmpseq1);*/
      s2 = s1 + strlen(tmpseq3);
      *s1 = '\0';
      s1 = tmpseq2;
#ifdef DEBUG
      fprintf(dbg, "%d %d %d %d [%s|%s]\n", *num - 1, r_start2, r_start, r_end,
              s1, s2);
#endif

      /* replace previous alignment with new */
      del_1 (*num - 1, r_start, r_end - r_start);

      ins_str (*num - 1, r_start, tmpsq -> seq);

      if (*s2) {
        ins_str (*num - 1, r_start + tmpsq -> length + 1, s2);
        if (lens2 < strlen(s2)) {
          for (num2 = sq_list; (*num2 >= 0) && (num2 != num); num2++) {
            for (i = 0; i < strlen(s2) - lens2; i++)
              ins_1 (*num2 - 1, r_start + tmpsq -> length + lens1 + lens2 + 1,
                     1, '-');
          }
          lens2 = strlen(s2);
        } else {
          for (i = 0; i < lens2 - strlen(s2); i++)
            ins_1 (*num - 1, r_start + tmpsq -> length + 1, 1, '-');
        }
      }
/*
      else if (r_end2 != r_end) {
        for (i = 0; i < entry[*num - 1] -> length - r_end + lens2; i++)
          ins_1 (*num - 1, r_end2, 1, '-');
      }
*/
      else {
        for (i = 0; i < lens2; i++)
          ins_1 (*num - 1, r_start + tmpsq -> length + 1, 1, '-');
      }

      if (*s1) {
        ins_str (*num - 1, r_start2, s1);
        if (lens1 < strlen(s1)) {
          for (num2 = sq_list; (*num2 >= 0) && (num2 != num); num2++) {
            for (i = 0; i < strlen(s1) - lens1; i++)
              ins_1 (*num2 - 1, r_start2, 1, '-');
          }
          /* r_end += strlen(s1) - lens1; */
          lens1 = strlen(s1);
        } else {
          for (i = 0; i < lens1 - strlen(s1); i++)
            ins_1 (*num - 1, r_start2, 1, '-');
        }
      } else {
        for (i = 0; i < lens1; i++)
          ins_1 (*num - 1, r_start2, 1, '-');
      }

#if 0
      ins_str (*num - 1, r_start, tmpsq -> seq);

      if (*s2) {
        ins_str (*num - 1, r_end2, s2);
        if (lens2 < strlen(s2)) {
          for (num2 = sq_list; (*num2 >= 0) && (num2 != num); num2++) {
            for (i = 0; i < strlen(s2) - lens2; i++)
              ins_1 (*num2 - 1, r_end2 + lens1 + lens2, 1, '-');
          }
          lens2 = strlen(s2);
        } else {
          for (i = 0;
               i < lens2 - strlen(s2); i++)
            ins_1 (*num - 1, r_end2, 1, '-');
        }
      }
/*
      else if (r_end2 != r_end) {
        for (i = 0; i < entry[*num - 1] -> length - r_end + lens2; i++)
          ins_1 (*num - 1, r_end2, 1, '-');
      }
*/
      else {
        for (i = 0; i < lens2; i++)
          ins_1 (*num - 1, r_end2, 1, '-');
      }

      if (*s1) {
        ins_str (*num - 1, r_start2, s1);
        if (lens1 < strlen(s1)) {
          for (num2 = sq_list; (*num2 >= 0) && (num2 != num); num2++) {
            for (i = 0; i < strlen(s1) - lens1; i++)
              ins_1 (*num2 - 1, r_start2, 1, '-');
          }
          /* r_end += strlen(s1) - lens1; */
          lens1 = strlen(s1);
        } else {
          for (i = 0; i < lens1 - strlen(s1); i++)
            ins_1 (*num - 1, r_start2, 1, '-');
        }
      } else {
        for (i = 0; i < lens1; i++)
          ins_1 (*num - 1, r_start2, 1, '-');
      }
#endif

      free (tmpseq1);
      free (tmpseq2);
      disp_all ();
      num++;
    }
    /* synchronize the anchors */
    sync_anchor2 (sq_list);

    /* strip anchors */
    strip_anchor2 (sq_list);

    protect = save_protect;
    fclose(fin);
#ifdef DEBUG
    fclose(dbg);
#endif
#ifndef DEBUG
    unlink(finname);
    unlink(finnameimg);
#endif
    disp_all ();

    return;
}
