
#ifndef LINT
static char *sccs_sid = "@(#)sysload.c	1.2 3/21/89 MASE";
#endif

#ifdef sun
/*  File Header 
 *
 * $Source: /home/bdlyre/ji/proj/src/sysload/RCS/sysload.c,v $
 * $Author: ji $
 * $Revision: 1.5 $
 * $Date: 88/12/01 15:13:57 $
 *
 *
 *
 * Imports (functions) :
 *
 * Imports (variables) : 
 *
 * Exports (functions) : sysload()
 *
 * Exports (variables) :
 */

/*  HISTORY 
 *  9-Dec-88  John Ioannidis (ji@bdblues.altair.fr)
 *	Performance sucks. Changed the ld line so that it strips the
 *	resulting executable of its symbol table, but can now recover the
 *	entry point simply by specifying it in the ld command line and
 *	then reading it off the header. I should have thought of that
 *	from the beginning.
 *	
 *
 *  9-Dec-88  John Ioannidis (ji@bdblues.altair.fr)
 *	fixed minor problem with strcpy vs strncpy
 *	
 *
 *  1-Dec-88  John Ioannidis (ji@bdblues.altair.fr)
 *	changed the includes a bit
 *
 * 29-Nov-88  John Ioannidis (ji) at gip-altair 
 *	* The object file and the main executable are 
 *	  given as a full pathnames.
 *	
 *	* The symbol name is not given -- it is assumed that
 *	  there is only one global Text symbol in the .o file
 *	
 *	* Both the address of the symbol and the address of the malloc'ed
 *	  block are returned.
 *	
 *	* The temporary filename gets a unique name  and is put in /tmp
 *	  and gets deleted!
 *
 *  6-Nov-88  John Ioannidis (ji) at gip-altair 
 *	First draft, to use the standard loader
 *
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/file.h>
#include <a.out.h>

#include "sysload.h"

static struct exec *hdr, hdr1;
static caddr_t fdp;

static scannlist();

Sysld
sysload(filename, mainname)
char *filename;
char *mainname;
{
	static char bigline[MAXPATHLEN*2+128]; /* plenty o' space */
	static char tmpaout[]="/tmp/tmpaoutXXXXXX";

	int fd, size;
	struct nlist lnl;
	caddr_t p;
	Sysld retval;
	
	/*
	 * find how much storage we'll need for text/data/bss
	 */

	fd = open(filename, 0);
	if (fd < 0)
	{
		perror(filename);
		goto err_ret;
	}

	lnl.n_un.n_strx = 0;
	lnl.n_type = N_TEXT | N_EXT;
	lnl.n_value = 0;
	
	scannlist(fd, &lnl);
	
	if (!lnl.n_un.n_name || !*lnl.n_un.n_name)
	{
		fprintf(stderr, "sysload: cannot get %s's namelist\n",
			filename);
		goto err_ret;
	}
	
	size = hdr->a_text + hdr->a_data + hdr->a_bss;	
	close(fd);

	p = (caddr_t)malloc(size);
	if (!p)
	{
		perror("sysload: malloc");
		goto err_ret;
	}

	bzero(p, size);

	/*
	 * Now we know where the final code will be loaded. 
	 * Do the linkage editing
	 */

	mktemp(tmpaout);
	
#ifdef SUN4_0
	sprintf(bigline, "ld -Bstatic -A %s -o %s -T %x -e %s -s %s", 
		mainname, tmpaout, p, lnl.n_un.n_name, filename);
#else 
	sprintf(bigline, "ld -A %s -o %s -T %x -e %s -s %s", 
		mainname, tmpaout, p, lnl.n_un.n_name, filename);
#endif

	if (system(bigline))
	  goto err_ret;

	fd = open(tmpaout, 0);

#ifdef oldcode
	if (scannlist(fd, &lnl) == -1)
	  goto err_ret;
#endif
	scannlist(fd, 0);		/* mmap fd as a side effect */
	
#ifdef DEBUG
	fprintf(stderr, "sysload:  name=%s, type=%x, value=0x%08x\n",
		lnl.n_un.n_name, lnl.n_type, lnl.n_value);
#endif

#ifdef SUN4_0
	bcopy(fdp+N_TXTOFF(*hdr), p, hdr->a_text+hdr->a_data);
#else
	lseek(fd, N_TXTOFF(*hdr), L_SET);
	read(fd, p, hdr->a_text+hdr->a_data);
#endif

	retval.sysl_mblock = (caddr_t) p;
	retval.sysl_entry = (int (*)())hdr->a_entry;

	close(fd);
	unlink(tmpaout);
	if (lnl.n_un.n_name)
	  free(lnl.n_un.n_name);
	
	return retval;
	
      err_ret:
	close(fd);
	unlink(tmpaout);
	if (lnl.n_un.n_name)
	  free(lnl.n_un.n_name);

	if (p)
	  free(p);
	retval.sysl_mblock = (caddr_t) NULL;
	retval.sysl_entry = (int (*)())NULL;
	return retval;
}

static 
scannlist(fd, mnl)
int fd;
struct nlist *mnl;
{
	/*
	 * scan the namelist of the file for a matching entry:
	 * - if the n_un.n_name field is non-null and points to 
	 *   a non-null string, look up that name and fill in the
	 *   n_type and n_value fields.
	 * - if the n_type field is non-zero, lookup the first 
	 *   entry that matches that type. This is used to find
	 *   the first/only global text symbol in a .o file
	 */

	struct nlist *nl, nl1;
	int smoff, stoff;
#ifdef SUN4_0
	struct stat stbuf;
#endif
	static char symname1[256];
	
	enum { BYNAME, BYTYPE, BYVALUE } srch;
	
#ifdef DEBUG
	fprintf(stderr, "scannlist: name=%s, type=%x, value=0x%08x\n",
		mnl->n_un.n_name, mnl->n_type, mnl->n_value);
#endif

#ifdef DEBUG
	fprintf(stderr, "scannlist: srch=%d\n", srch);
#endif

#ifdef SUN4_0
	fstat(fd, &stbuf);
	fdp = (caddr_t)mmap(0, stbuf.st_size, PROT_READ|PROT_EXEC, 
			    MAP_PRIVATE, fd, 0);
	hdr = (struct exec *)fdp;
#else
	lseek(fd, 0L, L_SET);
	read(fd, &hdr1, sizeof(hdr1));
	hdr = &hdr1;
#endif	

	smoff = N_SYMOFF(*hdr);
	stoff = N_STROFF(*hdr);

	if (!mnl)
	  return 0;
	
	if (mnl->n_un.n_name && *mnl->n_un.n_name)
	  srch = BYNAME;
	else if (mnl->n_type)
	  srch = BYTYPE;
	else if (mnl->n_value)
	  srch = BYVALUE;
	else
	  return -1;

	while (smoff < stoff)
	{

#ifdef SUN4_0
		nl = (struct nlist *)(fdp+smoff);
		strncpy(symname1, (char *)(fdp+stoff+nl->n_un.n_strx), 255);
#else
		lseek(fd, smoff, L_SET);
		read(fd, &nl1, sizeof(nl1));
		nl = &nl1;
		lseek(fd, stoff+nl->n_un.n_strx, L_SET);
		read(fd, symname1, 256);
#endif

		smoff += sizeof(struct nlist);

		switch (srch)
		{
		      case BYNAME:
			if(!strcmp(symname1, mnl->n_un.n_name))
			{
				mnl->n_type = nl->n_type;
				mnl->n_value = nl->n_value;
				return 0;
			}
			break;

		      case BYTYPE:
			if(nl->n_type == mnl->n_type)
			{
				mnl->n_un.n_name = 
				  (char *) malloc(strlen(symname1)+1);
				strcpy(mnl->n_un.n_name, symname1);
				mnl->n_value = nl->n_value;
				return 0;
			}
			break;

		      case BYVALUE:
			if(nl->n_value == mnl->n_value)
			{
				mnl->n_un.n_name = 
				  (char *) malloc(strlen(symname1)+1);
				strcpy(mnl->n_un.n_name, symname1);
				mnl->n_type = nl->n_type;
				return 0;
			}
			break;
		}
	}
	return -1;
}
#endif sun
